/* #include in your C[++] programme */

#ifndef IN_LIB_2

#if defined _DOS || defined _MSDOS
  typedef unsigned long DWORD;
#else
  typedef unsigned int	DWORD;
#endif
  typedef unsigned char BYTE;

#ifndef FLOAT_DATA
#  define FLOAT_DATA	0  /* 0: short, 1: float data */
#endif
#define METAXPON_VERSION (0x10200 + FLOAT_DATA)	 /* 1.02 */
#define INT_BUF_SIZE	(43042U * sizeof(DWORD)) /* Total internal data buffer size */

#pragma pack(1)
struct MXdata {
	DWORD Version;	   /* Fixed point 16.16 */
	DWORD Padding;	   /* Align next pointers to 8 B to avoid crash on Solaris 64-bit SPARC */
	void *InBuf;	   /* Input buffer address: allocate 2 * 4 * 1024 * OutBufSize + 16 bytes */
	void *OutBuf;	   /* n output buffers address: allocate n * 1024 * OutBufSize + 16 bytes */
	void *Memory;	   /* Processing memory address: allocate INT_BUF_SIZE B for internal use */
	DWORD Internal[10 + 4 * sizeof(void *)]; /* Private fields: don't touch them */
	DWORD Tempo;	   /* Output tempo, fixed point 16.16 */
	DWORD Threshold;   /* Attack detection level (optional), fixed point 16.16 */
	DWORD Last;	   /* Bytes to process before data end, aligned at 4 bytes */
	BYTE  Empty;	   /* Input buffer empty, set when ready to fill Buffer */
	BYTE  Half;	   /* Currently processed input buffer half (0 or 1) */
	BYTE  E0F;	   /* 0: no data end, 1: end in the first half, 2: end in the second half */
	BYTE  OutBufNum;   /* Output buffer number */
	BYTE  OutBufSizeK; /* Output buffer size [KB]: can be 2*,4*,8,16,32 (*sometimes: see API) */
	BYTE  MathUnit;	   /* (optional) 0: use FPU, 1: use 3DNow!, 2: use SSE (x86 only) */
};			   /* "optional": set by MXinit */
#pragma pack()

#endif	/* IN_LIB_2 */
#ifndef IN_LIB_1

#ifndef __cdecl
#  if defined __GNUC__ && (__GNUC__ > 2 || __GNUC__ == 2 && __GNUC_MINOR__ > 7) && defined __i386__
#    define __cdecl __attribute__((__cdecl__))
#  elif defined __NDPC__
#    define __cdecl \

#  elif defined __ACK__ || defined __SUNPRO_C || !defined __i386 && !defined __i386__ && !defined _M_I386 && !defined _M_IX86 && !defined __CC386__ && !defined __INTEL__ && !defined __I86__ && !defined _X86_
#    define __cdecl
#  endif
#endif

#ifdef __cplusplus
extern "C" {	/* see the API description for more info */
#endif
	int __cdecl MXinit(struct MXdata *);	/* Initialise internal data */
	int __cdecl MXstart(struct MXdata *);	/* Call before each new stream */
	int __cdecl MXprocess(struct MXdata *);	/* Process data */
#ifdef __cplusplus
}
#endif

#endif	/* IN_LIB_1 */
