CPU 586

section .text

%include "vocbufp.i"

%ifdef static
    %if PRO
	%define  GetSIMD  GetSIMD_pro
	%define _GetSIMD _GetSIMD_pro
	%define  MXinit  MXinitPro
	%define _MXinit _MXinitPro
	%define  MXprocess  MXprocessPro
	%define _MXprocess _MXprocessPro
	%define  VocInit  MXinit_pro
	%define _VocInit _MXinit_pro
	%define  VocProcess_fpu  MXprocess_fpu_pro
	%define _VocProcess_fpu _MXprocess_fpu_pro
	%define  VocProcess_k3d  MXprocess_k3d_pro
	%define _VocProcess_k3d _MXprocess_k3d_pro
	%define  VocProcess_sse  MXprocess_sse_pro
	%define _VocProcess_sse _MXprocess_sse_pro
    %endif
%endif

extern VocInit
extern VocProcess_fpu
extern VocProcess_k3d
extern VocProcess_sse


;;; ..start:

%ifndef static

global _DLLEntry
_DLLEntry:
	mov	eax,1
	ret	3*4
%endif


global	MXinit
global _MXinit
 MXinit:
_MXinit:

	call	_GetSIMD

	push	ebx
	mov	ebx,[esp+2*4]
	mov	byte [ebx+VB.fpu],0
;;;	.if eax==001b || eax==011b || eax==101b
    cmp    eax, byte 001h
    je	   @C0002
    cmp    eax, byte 003h
    je	   @C0002
    cmp    eax, byte 005h
    jne    @C0001
@C0002:
		mov	byte [ebx+VB.fpu],1
;;;	.elseif eax & 010b
    jmp    short @C0005
@C0001:
    test   eax, 002h
    je	   @C0006
		mov	byte [ebx+VB.fpu],2
;;;	.endif
@C0006:
@C0005:
	pop	ebx
	jmp	VocInit


global	MXprocess
global _MXprocess
 MXprocess:
_MXprocess:

	mov	eax,[esp+4]
	mov	al,[eax+VB.fpu]

	cmp	al,1
	je	VocProcess_k3d

	cmp	al,2
	je	VocProcess_sse

	jmp	VocProcess_fpu


; GetSIMD - returns information about CPU SIMD capabilities
; Result: bit 0 - 3DNow! technology supported
;	  bit 1 - Streaming SIMD Extensions supported
;	  bit 2 - Processor family is 7 or above. This bit can be used to
;		  choose between SSE and 3DNow! when both are present
;
global	GetSIMD
global _GetSIMD
 GetSIMD:
_GetSIMD:
;;;
    push   ebp
    push   ebx
    push   ecx
    push   edx
	xor	ebp,ebp
	pushfd
	pop	eax
	mov	ebx,eax
	xor	eax,00200000h
	push	eax
	popfd
	pushfd
	pop	eax

;;;	.if eax != ebx
    cmp    eax, ebx
    je	   @C0008
		mov	eax,1
		cpuid
		and	ah,0Fh
		add	ah,byte -7
		adc	ebp,byte 3		; Set bit 2 if Processor Family >= 7
		and	ebp,byte 4
		shr	edx,24
		and	edx,byte 2
		or	ebp,edx 		; Set bit 1 if SSE supported
		mov	eax,80000000h
		cpuid
;;;		.if eax > 80000000h
    cmp    eax, 080000000h
    jbe    @C000A
			mov	eax,80000001h
			cpuid
			shr	edx,31
			or	ebp,edx 	; Set bit 0 if 3DNow! supported
;;;		.endif
;;;	.endif
@C000A:
@C0008:

	mov	eax,ebp
;;;	ret
    pop    edx
    pop    ecx
    pop    ebx
    pop    ebp
    ret
