; M E T A X P O N   a u d i o	t i m e - s c a l i n g   l i b r a r y
;
; FPU Edition
; Supports single precision floating point data

.486
ifndef VOODOO
	.model flat
	BEG_CODE	textequ <.code>
	END_CODE	textequ <>
	BEG_CONST	textequ <.const>
	END_CONST	textequ <>
	DIST		textequ <near>
else
	_DATA	segment use16 para public 'DATA'
	_DATA	ends
	_TEXT	segment use16 para public 'CODE'
	_TEXT	ends
	DGROUP	group	_DATA
	assume	ds:_DATA,cs:_TEXT

	BEG_CODE	textequ <_TEXT segment>
	END_CODE	textequ <_TEXT ends>
	BEG_CONST	textequ <_DATA segment>
	END_CONST	textequ <_DATA ends>
	DIST		textequ <far>
endif

option casemap:none, language:C


ifdef DEBUG

include windows.inc
includelib kernel32.lib

summon	macro	func_name:req, args:vararg

	local	i, rev_params, imp_func_name

	rev_regs textequ <>
	i = 0

%	for	arg, <args>
		rev_regs	catstr	<arg> , <,> , rev_regs
	endm

%	for	arg, <rev_regs>
		push	arg
		i = i + 4
	endm

%	imp_func_name	catstr	<_imp__> , <&func_name> , <@> , %i
	extern	imp_func_name: dword
	call	imp_func_name
endm

endif

BEG_CODE

; Fast Fourier Transform
;
fft	proc	stdcall private uses ebx ecx edx esi edi Array: dword, FrameBit: dword, sign: dword

	local	step_r: real8
	local	step_i: real8
	local	half: real4

		fld1
		fld1
		fadd	st,st
		fdiv
		fstp	half

		mov	cl,byte ptr FrameBit
		mov	eax,2*real4
		mov	esi,eax			; i=1  (*2*real4)
		sal	eax,cl
		mov	ebx,Array
		mov	ecx,eax
		mov	edx,eax
		mov	edi,eax
		sub	ecx,esi			; FrameSize-1 (*2*real4)
		add	eax,ebx
		shr	edi,1			; j=FrameSize/2 (*2*real4)
		push	eax			; ArrayEnd

		test	byte ptr sign+3,80h
		jnz	fft_inverse

copy_reverse:	cmp	esi,edi
		jnb	bit_reverse

		fld	real4 ptr [ebx+esi]
		fld	real4 ptr [ebx+esi+real4]
		fld	real4 ptr [ebx+edi]
		fld	real4 ptr [ebx+edi+real4]
		fstp	real4 ptr [ebx+esi+real4]
		fstp	real4 ptr [ebx+esi]
		fstp	real4 ptr [ebx+edi+real4]
		fstp	real4 ptr [ebx+edi]

bit_reverse:	mov	eax,edx
bit_reverse1:	shr	eax,1
		sub	edi,eax
		jnb	bit_reverse1
		add	edi,eax
		add	edi,eax

		add	esi,2*real4
		cmp	esi,ecx
		jne	copy_reverse


		pop	edi

first_k:	fld	real4 ptr [ebx+2*2*real4]	; R[i+2]
		fld	st
		fld	real4 ptr [ebx+3*2*real4]	; R[i+3]
		fsub	st(2),st			; r.i = R[i+2] - R[i+3]
		fadd					; e.r = R[i+2] + R[i+3]
		fld	st				; e.r
		fld	real4 ptr [ebx]			; R[i]
		fld	st
		fld	real4 ptr [ebx+1*2*real4]	; R[i+1]
		fadd	st(2),st			; q.r = R[i] + R[i+1]
		fsub					; w.r = R[i] - R[i+1]
		fld	real4 ptr [ebx+2*2*real4+real4] ; I[i+2]
		fst	st(6)
		fld	real4 ptr [ebx+3*2*real4+real4] ; I[i+3]
		fadd	st(7),st			; e.i =	 I[i+2] + I[i+3]
		fsubr					; r.r = -I[i+2] + I[i+3]

		fld	st				; r.r
		fadd	st,st(2)			; R[i+1] = w.r + r.r
		fstp	real4 ptr [ebx+1*2*real4]	; R[i+1]
		fsub					; R[i+3] = w.r - r.r
		fstp	real4 ptr [ebx+3*2*real4]	; R[i+3]
		fsubr	st(2),st			; R[i+2] = q.r - e.r
		fadd					; R[i]	 = q.r + e.r
		fstp	real4 ptr [ebx]			; R[i]
		fstp	real4 ptr [ebx+2*2*real4]	; R[i+2]

		fld	st				; r.i
		fld	real4 ptr [ebx+real4]		; I[i]
		fld	st
		fld	real4 ptr [ebx+1*2*real4+real4] ; I[i+1]
		fsub	st(2),st			; w.i = I[i] - I[i+1]
		fadd					; q.i = I[i] + I[i+1]
		fld	st				; q.i
		fadd	st,st(5)			; I[i]	 = q.i + e.i
		fstp	real4 ptr [ebx+real4]		; I[i]
		fsubrp	st(4),st			; I[i+2] = q.i - e.i
		fsubr	st(2),st			; I[i+3] = w.i - r.i
		fadd					; I[i+1] = w.i + r.i
		fstp	real4 ptr [ebx+1*2*real4+real4] ; I[i+1]
		fstp	real4 ptr [ebx+3*2*real4+real4] ; I[i+3]
		fstp	real4 ptr [ebx+2*2*real4+real4] ; I[i+2]

		add	ebx,4*2*real4
		cmp	ebx,edi
		jb	first_k

		jmp	composition


fft_inverse:	fild	FrameBit
		fchs
		fld1
		fscale

copy_reverse_i: cmp	esi,edi
		ja	bit_reverse_i

		fld	real4 ptr [ebx+esi]
		fmul	st,st(1)
		fld	real4 ptr [ebx+esi+real4]
		fmul	st,st(2)
		fld	real4 ptr [ebx+edi]
		fmul	st,st(3)
		fld	real4 ptr [ebx+edi+real4]
		fmul	st,st(4)
		fstp	real4 ptr [ebx+esi+real4]
		fstp	real4 ptr [ebx+esi]
		fstp	real4 ptr [ebx+edi+real4]
		fstp	real4 ptr [ebx+edi]

bit_reverse_i:	mov	eax,edx
bit_reverse1_i: shr	eax,1
		sub	edi,eax
		jnb	bit_reverse1_i
		add	edi,eax
		add	edi,eax

		add	esi,2*real4
		cmp	esi,ecx
		jne	copy_reverse_i

		fld	real4 ptr [ebx]
		fmul	st,st(1)
		fld	real4 ptr [ebx+real4]
		fmul	st,st(2)
		fstp	real4 ptr [ebx+real4]
		fstp	real4 ptr [ebx]

		fld	real4 ptr [ebx+esi]
		fmul	st,st(1)
		fld	real4 ptr [ebx+esi+real4]
		fmulp	st(2),st
		fstp	real4 ptr [ebx+esi]
		fstp	real4 ptr [ebx+esi+real4]


		pop	edi

first_k_inv:	fld	real4 ptr [ebx+2*2*real4]	; R[i+2]
		fld	st
		fld	real4 ptr [ebx+3*2*real4]	; R[i+3]
		fsubr	st(2),st			; r.i = -R[i+2] + R[i+3]
		fadd					; e.r =	 R[i+2] + R[i+3]
		fld	st				; e.r
		fld	real4 ptr [ebx]			; R[i]
		fld	st
		fld	real4 ptr [ebx+1*2*real4]	; R[i+1]
		fadd	st(2),st			; q.r = R[i] + R[i+1]
		fsub					; w.r = R[i] - R[i+1]
		fld	real4 ptr [ebx+2*2*real4+real4] ; I[i+2]
		fst	st(6)
		fld	real4 ptr [ebx+3*2*real4+real4] ; I[i+3]
		fadd	st(7),st			; e.i = I[i+2] + I[i+3]
		fsub					; r.r = I[i+2] - I[i+3]

		fld	st				; r.r
		fadd	st,st(2)			; R[i+1] = w.r + r.r
		fstp	real4 ptr [ebx+1*2*real4]	; R[i+1]
		fsub					; R[i+3] = w.r - r.r
		fstp	real4 ptr [ebx+3*2*real4]	; R[i+3]
		fsubr	st(2),st			; R[i+2] = q.r - e.r
		fadd					; R[i]	 = q.r + e.r
		fstp	real4 ptr [ebx]			; R[i]
		fstp	real4 ptr [ebx+2*2*real4]	; R[i+2]

		fld	st				; r.i
		fld	real4 ptr [ebx+real4]		; I[i]
		fld	st
		fld	real4 ptr [ebx+1*2*real4+real4] ; I[i+1]
		fsub	st(2),st			; w.i = I[i] - I[i+1]
		fadd					; q.i = I[i] + I[i+1]
		fld	st				; q.i
		fadd	st,st(5)			; I[i]	 = q.i + e.i
		fstp	real4 ptr [ebx+real4]		; I[i]
		fsubrp	st(4),st			; I[i+2] = q.i - e.i
		fsubr	st(2),st			; I[i+3] = w.i - r.i
		fadd					; I[i+1] = w.i + r.i
		fstp	real4 ptr [ebx+1*2*real4+real4] ; I[i+1]
		fstp	real4 ptr [ebx+3*2*real4+real4] ; I[i+3]
		fstp	real4 ptr [ebx+2*2*real4+real4] ; I[i+2]

		add	ebx,4*2*real4
		cmp	ebx,edi
		jb	first_k_inv


composition:	fldpi
		fmul	half
		fmul	half		; pi/4
		mov	eax,4*2*real4	; CurBlockSize (cbs) = 4
		mov	esi,eax
		mov	edx,FrameBit
		sub	edx,2		; k

k_loop:		add	eax,eax		; CurBlockSize*2
		mov	ebx,Array	; i=0
		mov	ecx,2*real4	; j=1

first_i_loop:	fld	real4 ptr [ebx]		; R[i]
		fld	real4 ptr [ebx+real4]	; I[i]
		fld	real4 ptr [ebx+esi]	; R[i+cbs]
		fld	real4 ptr [ebx+esi+real4];I[i+cbs]
		fld	st(3)			; R[i]
		fld	st(3)			; I[i]
		fsub	st,st(2)		; I[i]-I[i+cbs]
		fstp	real4 ptr [ebx+esi+real4];I[i+cbs] = I[i]-I[i+cbs]
		fsub	st,st(2)		; R[i]-R[i+cbs]
		fstp	real4 ptr [ebx+esi]	; R[i+cbs] = R[i]-R[i+cbs]
		faddp	st(2),st		; I[i]+I[i+cbs]
		faddp	st(2),st		; R[i]+R[i+cbs]
		fstp	real4 ptr [ebx+real4]	; I[i] = I[i]+I[i+cbs]
		fstp	real4 ptr [ebx]		; R[i] = R[i]+R[i+cbs]

		add	ebx,eax
		cmp	ebx,edi
		jb	first_i_loop

		fst	st(1)		; pi/CurBlockSize
		fsincos
		fst	step_r		; shift_r
		fxch
		fimul	sign
		fst	step_i		; shift_i
		jmp	j_loop_entry

j_loop:		fld	step_r
		fld	step_i
		fld	st(1)		; step_r
		fmul	st,st(4)	; step_r*shift_r
		fld	st(1)		; step_i
		fmul	st,st(4)	; step_i*shift_i
		fsub			; shift_r*step_r - shift_i*step_i

		fxch	st(4)		; shift_r
		fmul			; shift_r*step_i
		fxch	st(2)		; shift_i
		fmul			; shift_i*step_r
		fadd			; shift_r*step_i + shift_i*step_r

j_loop_entry:	mov	ebx,ecx		; i=j
		add	ebx,Array

i_loop:		fld	real4 ptr [ebx+esi]	; R[i+cbs]
		fld	real4 ptr [ebx+esi+real4];I[i+cbs]
		fld	st(3)			; shift_r
		fmul	st,st(2)		; R[i+cbs]*shift_r
		fld	st(3)			; shift_i
		fmul	st,st(2)		; I[i+cbs]*shift_i
		fsub				; tr = R[i+cbs]*shift_r - I[i+cbs]*shift_i

		fxch	st(2)			; R[i+cbs]
		fmul	st,st(3)		; R[i+cbs]*shift_i
		fxch				; I[i+cbs]
		fmul	st,st(4)		; I[i+cbs]*shift_r
		fadd				; ti = R[i+cbs]*shift_i + I[i+cbs]*shift_r

		fld	real4 ptr [ebx]		; R[i]
		fld	real4 ptr [ebx+real4]	; I[i]
		fld	st(3)			; tr
		fsubr	st,st(2)		; R[i]-tr
		fstp	real4 ptr [ebx+esi]	; R[i+cbs] = R[i]-tr
		fld	st(2)			; ti
		fsubr	st,st(1)		; I[i]-ti
		fstp	real4 ptr [ebx+esi+real4]; I[i+cbs] = I[i]-ti

		faddp	st(2),st		; ti+I[i]
		faddp	st(2),st		; tr+R[i]
		fstp	real4 ptr [ebx+real4]	; I[i] = I[i]+ti
		fstp	real4 ptr [ebx]		; R[i] = R[i]+tr

		add	ebx,eax
		cmp	ebx,edi
		jb	i_loop

		add	ecx,2*real4
		cmp	ecx,esi
		jb	j_loop

		fcompp
		fmul	half

		mov	esi,eax
		dec	edx
		jnz	k_loop

		fstp	st
		ret
fft	endp


; Vocode - Phase modifications
; FPU must be initialized to round_to_nearest or round_to_even mode!
;
END_CODE
BEG_CONST

include VOCBUFP.INC

ATTACK_LOCK	=	4	; Blocks after attack that can't have attack
ATTACK_BLOCK	=	1	; Number of successive blocks with unchanged input phase
ATTACK_AMPLIFY	=	1	; 1-Use attack amplification, 0-Don't use
ATTACK_AMP_LEVEL equ	1.4	; Level of amplification
ATTACK_TEMPO_LOCK  =	0	; Number of successive blocks with tempo locked to 100%
ATTACK_PHASE_BLOCK =	ATTACK_LOCK - ATTACK_BLOCK
ATTACK_TEMPO_BLOCK =	ATTACK_LOCK - ATTACK_TEMPO_LOCK

align 4
FFTsize dword	FFTSIZE*real4
H0PSIZE real4	@CatStr(%HOPSIZE,<.0>)			; FFTSIZE/OVERSAMP

END_CONST
BEG_CODE

Vocode	proc	private MagnS:dword, Real:dword, Imag:dword, OldInPhase:dword, OutPhase:dword,
		Peak:dword, InStep:dword, Energy:dword, Attack:dword, Level:real4

	local	OldPeak: dword
	local	MinV: real4
	local	MinI: dword
	local	temp_i: dword
	local	attack_flag: byte

		pushad

		mov	eax,Energy
		xor	ebx,ebx
		mov	ecx,[eax]		; Energy[0]
		mov	edx,[eax+real4]		; Energy[1]
		mov	[eax+real4],ecx		; Energy[1]=Energy[0]
		mov	[eax+2*real4],edx	; Energy[2]=Energy[1]
		mov	OldPeak,ebx		; OldPeak=0
		mov	MinI,ebx		; MinI=0

		mov	ecx,MagnS
		mov	esi,Real
		mov	edi,Imag

		fldz
		.repeat
			fld	real4 ptr [esi+ebx]	; Real[i]
			fmul	st,st
			fld	real4 ptr [edi+ebx]	; Imag[i]
			fmul	st,st
			fadd
			fst	real4 ptr [ecx+ebx]	; MagnS[i]
			fadd
			add	ebx,real4
		.until ebx > FFTSIZE/2*real4
		fstp	real4 ptr [eax]		; Energy[0]

		mov	edx,[ecx]		; MagnS[0]
		mov	MinV,edx

		mov	ecx,Attack
		mov	dl,[ecx]
		dec	dl
		jns	write_Attack

		mov	ebx,[eax+real4]		; Energy[1]
		cmp	[eax],ebx		; Energy[0]
		jna	condition
		cmp	[eax+2*real4],ebx	; Energy[2]
		jnb	condition
		fld	real4 ptr [eax+2*real4] ; Energy[2]
		fmul	Level
		fcomp	real4 ptr [eax]		; Energy[0]
		fnstsw	ax
		sahf
		jnb	condition

		mov	dl,ATTACK_LOCK
write_Attack:	mov	[ecx],dl

condition:	mov	al,ATTACK_PHASE_BLOCK
		sub	al,dl
		mov	attack_flag,al

		mov	eax,OutPhase
		mov	ebx,OldInPhase
		.if byte ptr [esi+real4-1] & 80h
			fldpi
		.else
			fldz
		.endif
		fst	real4 ptr [eax]
		fstp	real4 ptr [ebx]

		fild	FFTsize
		fld1
		fldpi
		fadd	st,st			; 2*Pi
		fdiv	st(1),st		; 1/(2*Pi)
		fdivr	st(2),st		; 2*PI/FFTSIZE/real4
		fld1
		fidiv	InStep			; 1/InStep

		mov	ebx,2*real4		; i=2
		.repeat
			mov	ecx,MagnS
			mov	eax,[ecx+ebx]		; MagnS[i]
			mov	edx,MinV
			sub	eax,edx
			sbb	ecx,ecx
			and	eax,ecx
			not	ecx
			add	eax,edx
			mov	MinV,eax
			mov	edx,MinI
			sub	edx,ebx
			and	ecx,edx
			add	ecx,ebx
			mov	MinI,ecx

			mov	temp_i,ebx
			add	ebx,MagnS
			mov	eax,[ebx-2*real4]	; MagnS[i-2]
			mov	edx,[ebx-1*real4]	; MagnS[i-1]
			sub	eax,edx
			sbb	ecx,ecx
			not	ecx
			and	eax,ecx
			add	eax,edx

			mov	edx,[ebx+1*real4]	; MagnS[i+1]
			sub	eax,edx
			sbb	ecx,ecx
			not	ecx
			and	eax,ecx
			add	eax,edx

			mov	edx,[ebx+2*real4]	; MagnS[i+2]
			sub	eax,edx
			sbb	ecx,ecx
			not	ecx
			and	eax,ecx
			add	eax,edx

			cmp	eax,[ebx]		; MagnS[i]
			mov	ebx,temp_i
			.if carry?			; eax < [ebx]
				fld	real4 ptr [edi+ebx]	; Imag[i]
				fld	real4 ptr [esi+ebx]	; Real[i]
				fpatan				; InPhase
				mov	ecx,OldInPhase
				mov	edx,OutPhase

				.if attack_flag & 80h
					fst	real4 ptr [ebx+edx]	; OutPhase[i]
				.else
					fild	temp_i
					mov	eax,Peak
					fmul	st,st(5)		; i*2*PI/FFTSIZE
					fild	InStep
					mov	eax,[eax+ebx]		; Peak[i]
					fmul	st,st(1)		; InStep*i*2*PI/FFTSIZE

					fld	st(2)			; InPhase
					fsub	real4 ptr [eax+ecx]	; OldInPhase[Peak[i]]

					fsubr

					fmul	st,st(5)		; / (2*Pi)
					fld	st
					frndint
					fsub
					fmul	st,st(4)		; Delta

					fmul	st,st(3)		; Delta/InStep
					fadd				; i*2*PI/FFTSIZE + Delta/InStep
					fmul	H0PSIZE
					fadd	real4 ptr [eax+edx]	; OutPhase[Peak[i]]

					fmul	st,st(4)		; / (2*Pi)
					fld	st
					frndint
					fsub
					fmul	st,st(3)		; * (2*Pi)
					fstp	real4 ptr [ebx+edx]	; OutPhase[i]
				.endif
				fstp	real4 ptr [ebx+ecx]	; OldInPhase[i]

				mov	eax,Peak
				mov	ecx,OldPeak		; j
				mov	edx,ecx			; OldPeak
				.while ecx <= MinI		; Mark peaks I
					mov	[eax+ecx],edx		; Peak[j] = OldPeak
					add	ecx,real4
				.endw

				mov	OldPeak,ebx		; OldPeak = i
				.while ecx < ebx		; Mark peaks II
					mov	[eax+ecx],ebx		; Peak[j] = OldPeak
					add	ecx,real4
				.endw

				mov	ecx,MagnS
				mov	eax,[ecx+ebx]		; MagnS[i]
				mov	MinI,ebx
				mov	MinV,eax
			.endif
			add	ebx,real4
		.until ebx == real4*(FFTSIZE/2-1)
		fcompp
		fcompp

		mov	eax,Peak
		mov	ecx,OldPeak		; j
		mov	edx,ecx			; OldPeak
		.while ecx < FFTSIZE/2*real4	; Mark peaks III
			mov	[eax+ecx],edx		; Peak[j] = OldPeak
			add	ecx,real4
		.endw

		mov	ecx,OldInPhase
		mov	ebp,OutPhase
		or	edx,-1			; CurPeak
		fldz				; zi=0
		fld1				; zr=1
		mov	ebx,1*real4		; i
		.repeat
			.if edx != [eax+ebx]
				mov	edx,[eax+ebx]
				fstp	st
				fstp	st
				fld	real4 ptr [ebp+edx]	; OutPhase[CurPeak]
				fsub	real4 ptr [ecx+edx]	; OldInPhase[CurPeak]
				fsincos
			.endif

			fld	real4 ptr [ebx+esi]	; Real[i]
			fld	real4 ptr [ebx+edi]	; Imag[i]
			fld	st(1)
			fld	st(1)
			fmul	st,st(5)
			fxch
			fmul	st,st(4)
			fsubr
			fstp	real4 ptr [ebx+esi]	; new Real[i]
			fmul	st,st(2)
			fxch
			fmul	st,st(3)
			fadd
			fstp	real4 ptr [ebx+edi]	; new Imag[i]
			add	ebx,real4
		.until ebx >= FFTSIZE/2*real4

		fcompp
		popad
		ret
Vocode	endp


; VocProcess - Main vocoder function
;
END_CODE
BEG_CONST

align 4
ife FLOAT_DATA
 max		 real4	+32767.0
 min		 real4	-65536.0
 quarter	 real4	 0.25
endif
normalize	 real4	 0.0000152587890625	; 1/65536
 if ATTACK_AMPLIFY
attack_amp_const real4	ATTACK_AMP_LEVEL
 endif

END_CONST
BEG_CODE

ifdef static
  if PRO
	VocProcess_fpu	textequ <MXprocess_fpu_pro>
  else
	VocProcess_fpu	textequ <MXprocess_fpu>
  endif
endif

VocProcess_fpu	proc	DIST uses ebx ecx edx esi edi vb: dword

	local	InStep: dword
	local	OldInBuffOfs: dword
	local	j: dword

	mov	esi,vb
	mov	al,[esi].VB.E0F
	.if al && !(al & 40h)
		and	eax,11b
		dec	eax
		neg	eax
		mov	ecx,[esi].VB.InBlkSz
		mov	edx,[esi].VB.Last
		and	eax,ecx
		mov	edi,[esi].VB.InBuff
		add	edi,eax
		add	edi,edx
		sub	ecx,edx
		shr	ecx,2
		xor	eax,eax
		rep	stos dword ptr es:[edi]
		or	[esi].VB.E0F,40h
	.endif

	mov	eax,[esi].VB.Speed
	add	eax,1 shl (InStep_shift-1)	; Round
	shr	eax,InStep_shift		; * HOPSIZE/10000h
	mov	InStep,eax

	mov	eax,[esi].VB.InBuffOfs
	mov	OldInBuffOfs,eax

	xor	eax,eax				; j=0
	.repeat
		mov	j,eax
		mov	ebx,[esi].VB.InBuffOfs
		mov	edx,[esi].VB.InBuff
		add	ebx,ebx				; * word
if FLOAT_DATA
		add	ebx,ebx				; * real4
endif
		mov	eax,[esi].VB.Comp
		mov	ecx,[esi].VB.Window
		xor	edi,edi				; i=0
		.repeat
if FLOAT_DATA
			fld	real4 ptr [edx+ebx]		; *(ib)
			fld	real4 ptr [edx+ebx+real4]	; *(ib+1)
else
			fild	word ptr [edx+ebx]		; *(ib)
			fild	word ptr [edx+ebx+word]		; *(ib+1)
endif
			fld	real4 ptr [ecx+edi]		; Window[i]
			add	ebx,SAMPLESIZE			; ib++; ib++
			fmul	st(1),st
			fmulp	st(2),st
			and	ebx,[esi].VB.QuadInBlSamsk	; % (4*INBLOCKSAM)
			fstp	real4 ptr [eax+2*edi+real4]	; Comp[i].i
			fstp	real4 ptr [eax+2*edi]		; Comp[i].r
 if PRO
			mov	dword ptr [eax+2*edi+FFTSIZE*real4],0
			mov	dword ptr [eax+2*edi+FFTSIZE*real4+real4],0
 endif
			add	edi,real4			; i++
		.until edi == FFTSIZE*real4 shr PRO

		invoke	fft, eax,FFTBITS,-1

		mov	eax,[esi].VB.Comp
		mov	ebx,real4			; i=1
		mov	ecx,[esi].VB.RealA
		mov	edx,[esi].VB.ImagA
		mov	edi,[esi].VB.ImagB
		mov	esi,[esi].VB.RealB
		.repeat
			fld	real4 ptr [eax+2*ebx]		; Comp[i].r
			fld	real4 ptr [eax+2*ebx+real4]	; Comp[i].i
			neg	ebx
			fld	st(1)
			fld	st(1)
			fld	real4 ptr [eax+2*real4*FFTSIZE+2*ebx+real4]; Comp[FFTSIZE-i].i
			fld	real4 ptr [eax+2*real4*FFTSIZE+2*ebx]	   ; Comp[FFTSIZE-i].r
			neg	ebx
			fsubr	st(5),st
			faddp	st(3),st
			fadd	st(3),st
			fsub
			fstp	real4 ptr [edx+ebx]		; ImagA[i]
			fstp	real4 ptr [ecx+ebx]		; RealA[i]
			fstp	real4 ptr [esi+ebx]		; RealB[i]
			fstp	real4 ptr [edi+ebx]		; ImagB[i]
			add	ebx,real4			; i++
		.until ebx == FFTSIZE/2*real4
		fld	real4 ptr [eax]			; Comp[0].r
		fld	real4 ptr [eax+real4]		; Comp[0].i
		fld	real4 ptr [eax+2*ebx]		; Comp[FFTSIZE/2].r
		fld	real4 ptr [eax+2*ebx+real4]	; Comp[FFTSIZE/2].i
		fldz
		fst	real4 ptr [edx]			; ImagA[0]
		fst	real4 ptr [edi]			; ImagB[0]
		fst	real4 ptr [edx+ebx]		; ImagA[FFTSIZE/2]
		fstp	real4 ptr [edi+ebx]		; ImagB[FFTSIZE/2]
		fadd	st,st
		fstp	real4 ptr [esi+ebx]		; RealB[FFTSIZE/2]
		fadd	st,st
		fstp	real4 ptr [ecx+ebx]		; RealA[FFTSIZE/2]
		fadd	st,st
		fstp	real4 ptr [esi]			; RealB[0]
		fadd	st,st
		fstp	real4 ptr [ecx]			; RealA[0]

		mov	esi,vb
		fild	[esi].VB.Threshold
		fmul	normalize
		push	eax
		fstp	real4 ptr [esp]

		lea	eax,[esi].VB.AttackL
		push	eax
		push	[esi].VB.EnergyL
		push	InStep
		push	[esi].VB.PeakL
		push	[esi].VB.OutPhaseL
		push	[esi].VB.OldInPhaseL
		push	[esi].VB.ImagA
		push	[esi].VB.RealA
		push	[esi].VB.MagnS
		call	Vocode
		add	esp,9*dword

		lea	eax,[esi].VB.AttackR
		push	eax
		push	[esi].VB.EnergyR
		push	InStep
		push	[esi].VB.PeakR
		push	[esi].VB.OutPhaseR
		push	[esi].VB.OldInPhaseR
		push	[esi].VB.ImagB
		push	[esi].VB.RealB
		push	[esi].VB.MagnS
		call	Vocode
		add	esp,10*dword

		mov	eax,[esi].VB.Comp
		mov	ebx,real4			; i=1
		mov	ecx,[esi].VB.RealA
		mov	edx,[esi].VB.ImagA
	;	mov	edi,[esi].VB.ImagB
		mov	esi,[esi].VB.RealB
		.repeat
			fld	real4 ptr [esi+ebx]		; RealB[i]
			fld	real4 ptr [ecx+ebx]		; RealA[i]
			fld	st(1)
			fld	st(1)
			fld	real4 ptr [edi+ebx]		; ImagB[i]
			fld	real4 ptr [edx+ebx]		; ImagA[i]
			fsub	st(5),st
			faddp	st(3),st
			fadd	st(3),st
			fsub
			fstp	real4 ptr [eax+2*ebx]		; Comp[i].r
			fstp	real4 ptr [eax+2*ebx+real4]	; Comp[i].i
			neg	ebx
			fstp	real4 ptr [eax+2*real4*FFTSIZE+2*ebx]	   ; Comp[FFTSIZE-i].r
			fstp	real4 ptr [eax+2*real4*FFTSIZE+2*ebx+real4]; Comp[FFTSIZE-i].i
			neg	ebx
			add	ebx,real4			; i++
		.until ebx == FFTSIZE/2*real4
		fld	real4 ptr [esi+ebx]		; RealB[FFTSIZE/2]
		fld	real4 ptr [ecx+ebx]		; RealA[FFTSIZE/2]
		fld	real4 ptr [esi]			; RealB[0]
		fld	real4 ptr [ecx]			; RealA[0]
		fadd	st,st
		fstp	real4 ptr [eax]			; Comp[0].r
		fadd	st,st
		fstp	real4 ptr [eax+real4]		; Comp[0].i
		fadd	st,st
		fstp	real4 ptr [eax+2*ebx]		; Comp[FFTSIZE/2].r
		fadd	st,st
		fstp	real4 ptr [eax+2*ebx+real4]	; Comp[FFTSIZE/2].i

		invoke	fft, eax,FFTBITS,1

 if ATTACK_AMPLIFY
		mov	esi,vb
		mov	ebx,[esi].VB.OutBuffOfs
		mov	ecx,[esi].VB.OutL
		mov	edx,[esi].VB.OutR

		mov	eax,dword ptr [esi].VB.AttackL	; "AttackL" & "AttackR" together! (both are WORDs)
		mov	edi,ATTACK_PHASE_BLOCK*10000h+ATTACK_PHASE_BLOCK
		sub	edi,eax				; Do SIMD style comparison
		and	edi,0FFF0FFF0h			;
		.if zero?
			mov	eax,[esi].VB.Comp
			mov	esi,[esi].VB.Window
			.repeat
				and	ebx,(FFTSIZE-1)*real4		; % FFTSIZE
				fld	real4 ptr [eax+2*edi]		; Comp[i].r
				fld	real4 ptr [eax+2*edi+real4]	; Comp[i].i
				fld	real4 ptr [esi+edi]		; Window[i]
				fmul	st(1),st
				fmulp	st(2),st
				fadd	real4 ptr [edx+ebx]		; OutR[(OutBuffOfs+i)%FFTSIZE]
				fstp	real4 ptr [edx+ebx]		;
				fadd	real4 ptr [ecx+ebx]		; OutL[(OutBuffOfs+i)%FFTSIZE]
				fstp	real4 ptr [ecx+ebx]		;
				add	edi,real4			; i++
				add	ebx,real4
			.until edi == FFTSIZE*real4 shr PRO
		.else
			fld	attack_amp_const
			fld	st
			sub	eax,(ATTACK_PHASE_BLOCK+1)*10000h+(ATTACK_PHASE_BLOCK+1)
			and	eax,0FFF0FFF0h				; Another SIMD style comparison
			.if !zero?
				fld1
				fstp	st(1)				; Attack in left channel
				.if ax
					fxch				; Attack in right channel
				.endif
			.endif
			mov	eax,[esi].VB.Comp
			mov	esi,[esi].VB.Window
			xor	edi,edi				; i=0
			.repeat
				and	ebx,(FFTSIZE-1)*real4		; % FFTSIZE
				fld	real4 ptr [eax+2*edi]		; Comp[i].r
				fmul	st,st(2)
				fld	real4 ptr [eax+2*edi+real4]	; Comp[i].i
				fmul	st,st(2)
				fld	real4 ptr [esi+edi]		; Window[i]
				fmul	st(1),st
				fmulp	st(2),st
				fadd	real4 ptr [edx+ebx]		; OutR[(OutBuffOfs+i)%FFTSIZE]
				fstp	real4 ptr [edx+ebx]		;
				fadd	real4 ptr [ecx+ebx]		; OutL[(OutBuffOfs+i)%FFTSIZE]
				fstp	real4 ptr [ecx+ebx]		;
				add	edi,real4			; i++
				add	ebx,real4
			.until edi == FFTSIZE*real4 shr PRO
			fcompp
		.endif
 else
		mov	esi,vb
		mov	eax,[esi].VB.Comp
		mov	ebx,[esi].VB.OutBuffOfs
		mov	ecx,[esi].VB.OutL
		mov	edx,[esi].VB.OutR
		mov	esi,[esi].VB.Window
		xor	edi,edi				; i=0
		.repeat
			and	ebx,(FFTSIZE-1)*real4		; % FFTSIZE
			fld	real4 ptr [eax+2*edi]		; Comp[i].r
			fld	real4 ptr [eax+2*edi+real4]	; Comp[i].i
			fld	real4 ptr [esi+edi]		; Window[i]
			fmul	st(1),st
			fmulp	st(2),st
			fadd	real4 ptr [edx+ebx]		; OutR[(OutBuffOfs+i)%FFTSIZE]
			fstp	real4 ptr [edx+ebx]		;
			fadd	real4 ptr [ecx+ebx]		; OutL[(OutBuffOfs+i)%FFTSIZE]
			fstp	real4 ptr [ecx+ebx]		;
			add	edi,real4			; i++
			add	ebx,real4
		.until edi == FFTSIZE*real4 shr PRO
 endif
		mov	esi,vb
		mov	eax,j
		movzx	edi,[esi].VB.LastFilledBuf
		mov	ebx,[esi].VB.OutBuffOfs
if FLOAT_DATA
		shl	eax,HOPSIZE_shift+3		; 2*HOPSIZE*j
else
		shl	eax,HOPSIZE_shift+2		; 2*HOPSIZE*j
endif
		imul	edi,[esi].VB.OutBlkSz		; LastFilledBuf*OUTBLOCKSAM*2
		add	edi,eax				; LastFilledBuf*OUTBLOCKSAM*2+2*HOPSIZE*j
		xor	eax,eax				; i=0
		add	edi,[esi].VB.OutBuff		; OutBuff+LastFilledBuf*OUTBLOCKSAM*2+2*HOPSIZE*j
		.repeat
			fld	real4 ptr [edx+ebx]		; OutR[OutBuffOfs+i]
			fld	real4 ptr [ecx+ebx]		; OutL[OutBuffOfs+i]
if FLOAT_DATA
			fstp	real4 ptr [edi+eax]		; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i]
			fstp	real4 ptr [edi+eax+real4]	; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i + 1]
else
			fld	st(1)
			fld	st(1)
			fld	max
			fadd	st(4),st
			fadd	st(3),st
			fsub	st(1),st
			fsubp	st(2),st
			fabs
			fsubp	st(2),st
			fabs
			fsubp	st(2),st

			fld	st(1)
			fld	st(1)
			fld	min
			fadd	st(4),st
			fadd	st(3),st
			fsub	st(1),st
			fsubp	st(2),st
			fabs
			faddp	st(2),st
			fabs
			faddp	st(2),st

			fmul	quarter
			fistp	word ptr [edi+eax]		; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i]
			fmul	quarter
			fistp	word ptr [edi+eax+word]		; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i + 1]
endif
			mov	real4 ptr [ecx+ebx],0		; OutL[OutBuffOfs+i]=0
			mov	real4 ptr [edx+ebx],0		; OutR[OutBuffOfs+i]=0

			add	eax,SAMPLESIZE			; i++
			add	ebx,real4
		.until eax == HOPSIZE*SAMPLESIZE

		and	ebx,(FFTSIZE-1)*real4		; OutBuffOfs=(OutBuffOfs+HOPSIZE)%FFTSIZE
		mov	[esi].VB.OutBuffOfs,ebx

 if ATTACK_TEMPO_LOCK
		mov	eax,ATTACK_TEMPO_BLOCK*10000h+ATTACK_TEMPO_BLOCK	; Do SIMD style comparison
		mov	ebx,InStep
		sub	eax,dword ptr [esi].VB.AttackL	; "AttackL" & "AttackR" together! (both are WORDs)
		sub	ebx,HOPSIZE
		and	eax,0FFF0FFF0h
		cmp	eax,1
		sbb	eax,eax
		and	eax,ebx
		add	eax,HOPSIZE
 else
		mov	eax,InStep
 endif
		add	eax,eax
		add	eax,[esi].VB.InBuffOfs		; InBuffOfs += 2*InStep
		and	eax,[esi].VB.QuadInBlSmask	; InBuffOfs & (4*INBLOCKSAM-1)
		mov	edx,eax
		mov	[esi].VB.InBuffOfs,eax

ifdef DEBUG

pusha
.if [esi].VB.E0F
	add	eax,eax
	call	print
	push	2020h
	mov	ecx,esp
	summon	GetStdHandle, STD_OUTPUT_HANDLE
	summon	WriteFile, eax,ecx,2,esp,NULL
	pop	eax
	mov	eax,[esi].VB.Last
	call	print
	push	2020h
	mov	ecx,esp
	summon	GetStdHandle, STD_OUTPUT_HANDLE
	summon	WriteFile, eax,ecx,2,esp,NULL
	pop	eax
	mov	al,[esi].VB.E0F
	call	print8
	push	0A0Dh
	mov	ecx,esp
	summon	GetStdHandle, STD_OUTPUT_HANDLE
	summon	WriteFile, eax,ecx,2,esp,NULL
	pop	eax
.endif
popa

endif

		mov	cl,[esi].VB.InBlkSamShInc	; InBuffOfs/(2*INBLOCKSAM)
		shr	eax,cl
	;	and	eax,1
		mov	[esi].VB.Half,al

		inc	eax				; Half + 1
		test	[esi].VB.E0F,al
		jz	@2
			or	[esi].VB.E0F,80h
			mov	eax,edx
			and	eax,[esi].VB.DualInBlSmask	; InBuffOfs & (2*INBLOCKSAM-1)
			add	eax,eax
if FLOAT_DATA
			add	eax,eax
endif
			cmp	eax,[esi].VB.Last		; 2*(InBuffOfs & (2*INBLOCKSAM-1)) >= Last
			jb	@3
			    @1: mov	eax,j
				inc	eax
				shl	eax,HOPSIZE_shift
				jmp	exit
	    @2: test	[esi].VB.E0F,80h
		jnz	@1

	    @3: mov	eax,j
		inc	eax					; j++
	.until al == [esi].VB.OutBlkHops

	xor	edx,OldInBuffOfs
	.if edx & [esi].VB.DualInblSam
		.if [esi].VB.E0F
			mov	al,[esi].VB.Half
			inc	al
			.if [esi].VB.E0F == al
				mov	edi,OldInBuffOfs
				and	edi,[esi].VB.DualInblSam
				xor	eax,eax
				add	edi,edi			; * word
if FLOAT_DATA
				add	edi,edi			; * real4
endif
				mov	ecx,[esi].VB.InBlkSz
				shr	ecx,2			; dword
				add	edi,[esi].VB.InBuff
				;cld
				rep	stos dword ptr es:[edi]
			.endif
		.else
			mov	[esi].VB.Empty,1
		.endif
	.endif

	or	eax,-1
exit:	ret

VocProcess_fpu	endp


; Call before each start of playback

ifndef nostart

VocStart	textequ <MXstart>
ifdef static
  if PRO
	VocStart	textequ <MXstartPro>
  endif
endif

VocStart	proc	DIST uses ebx ecx edi vb: dword

		mov	ebx,vb
		movzx	eax,[ebx].VB.OutBufferSzKB		; output buffer size [KB]
		mov	ecx,eax
		shr	cl,HOPSIZE_shift+2+FLOAT_DATA-10

		.if al != 2 && al != 4 && al != 8 && al != 16 && al != 32 || !cl
			or	eax,-1

		.else
			shl	eax,10
			mov	ecx,eax
			mov	[ebx].VB.OutBlkSz,eax		; Output buffer size [bytes]
			shl	eax,2
			mov	[ebx].VB.InBlkSz,eax		;  Input buffer size [bytes]
			shr	ecx,2+FLOAT_DATA
			mov	eax,ecx				; OUTBLOCKSAM
			shr	ecx,HOPSIZE_shift
			mov	[ebx].VB.OutBlkHops,cl		; OUTBLOCKSAM/HOPSIZE
			shl	eax,3
			mov	[ebx].VB.DualInblSam,eax	;  2*INBLOCKSAM
			bsf	ecx,eax
			mov	[ebx].VB.InBlkSamShInc,cl	;    INBLOCKSAM_shift+1
			dec	eax
			mov	[ebx].VB.DualInBlSmask,eax	;  2*INBLOCKSAM-1 (mask)
			inc	eax
			shl	eax,1
			dec	eax
			mov	[ebx].VB.QuadInBlSmask,eax	;  4*INBLOCKSAM-1 (mask)
			shl	eax,1+FLOAT_DATA
			mov	[ebx].VB.QuadInBlSamsk,eax	; (4*INBLOCKSAM-1)*IODATATYPE (mask)

			;cld
			xor	eax,eax
			mov	edi,[ebx].VB.OutL
			mov	ecx,FFTSIZE
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.OutR
			mov	ecx,FFTSIZE
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.OldInPhaseL
			mov	ecx,FFTSIZE/2
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.OldInPhaseR
			mov	ecx,FFTSIZE/2
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.OutPhaseL
			mov	ecx,FFTSIZE/2
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.OutPhaseR
			mov	ecx,FFTSIZE/2
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.PeakL
			mov	ecx,FFTSIZE/2
			rep	stos dword ptr es:[edi]
			mov	edi,[ebx].VB.PeakR
			mov	ecx,FFTSIZE/2
			rep	stos dword ptr es:[edi]
			mov	[ebx].VB.InBuffOfs,eax
			mov	[ebx].VB.OutBuffOfs,eax
			mov	[ebx].VB.Half,al
			mov	dword ptr [ebx].VB.AttackL,eax	; "AttackL" & "AttackR" together! (both are WORDs)
		.endif

		ret

VocStart	endp

endif


; Blackman window initialization

END_CODE
BEG_CONST

align 8
minus05		real8	-0.5
o08		real8	 0.08
o42		real8	 0.42
 if OVERSAMPBITS-PRO eq 3
o63		real8	 0.44547727214752494037253194812	; 0.63 / sqrt(2)
 else
o63		real8	 0.63
 endif

END_CONST
BEG_CODE

; Window[i]=0.63*(.42-.5*cos(2*PI*(i+.5)/FFTSIZE)+.08*cos(4*PI*(i+.5)/FFTSIZE))

ifdef static
  if PRO
	VocInit textequ <MXinit_pro>
  else
	VocInit textequ <MXinit>
  endif
endif

VocInit		proc	DIST uses ebx ecx vb: dword

		local	const0: real8	; 2*PI/FFTSIZE
		local	cw: word

		mov	ebx,vb
		.if [ebx].VB.Version != VERSION
			or	eax,-1

		.else
			mov	[ebx].VB.Threshold,20000h	; Default 2.0

			mov	ecx,[ebx].VB.InBuff
			add	ecx,15
			and	ecx,-16
			mov	[ebx].VB.InBuff,ecx

			mov	ecx,[ebx].VB.OutBuff
			add	ecx,15
			and	ecx,-16
			mov	[ebx].VB.OutBuff,ecx

			mov	ecx,[ebx].VB.Comp
			add	ecx,15
			and	ecx,-16

			mov	[ebx].VB.Comp,ecx
			add	ecx,MAXFFTSIZE*real4*2
			mov	[ebx].VB.Window,ecx
			add	ecx,MAXFFTSIZE*real4
			mov	[ebx].VB.OutL,ecx
			add	ecx,MAXFFTSIZE*real4
			mov	[ebx].VB.OutR,ecx
			add	ecx,MAXFFTSIZE*real4
			mov	[ebx].VB.OldInPhaseL,ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx].VB.OutPhaseL,ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx].VB.OldInPhaseR,ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx].VB.OutPhaseR,ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx].VB.PeakL,ecx
			add	ecx,MAXFFTSIZE/2*dword
			mov	[ebx].VB.PeakR,ecx
			add	ecx,MAXFFTSIZE/2*dword
			mov	[ebx].VB.MagnS,ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx].VB.RealA,ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx].VB.ImagA,ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx].VB.RealB,ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx].VB.ImagB,ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx].VB.EnergyL,ecx
			add	ecx,3*real4
			mov	[ebx].VB.EnergyR,ecx

			mov	word ptr const0,FFTSIZE shr (PRO+1)
			fnstcw	cw			; save FPU control word
			fninit				; reinitialize FPU
			fldpi
			fidiv	word ptr const0
			fstp	const0
			mov	ebx,[ebx].VB.Window
			mov	ecx,FFTSIZE shr PRO
			fld	minus05
			.repeat
				fld1
				fadd				; update i+.5
				fst	st(2)
				fmul	const0			; 2*PI*(i+.5)/FFTSIZE
				fst	st(1)			; angle for left cos
				fadd	st,st			;   "   "
				fcos				; right cos
				fmul	o08			; rightmost intermediate sum
				fxch				; store it and load angle for
				fcos				; left cos
				fmul	minus05
				fadd
				fadd	o42
				fmul	o63
				fstp	real4 ptr [ebx]		; store item and pop i+0.5
				add	ebx,real4		; update pointer
			.untilcxz			; repeat FFTSIZE times
			fstp	st			; restore FPU stack
			fldcw	cw			; restore FPU control word
		.endif

		ret

VocInit		endp


ifdef DEBUG

print	proc

	call	$+5
	ror	eax,16
	call	$+5
	xchg	al,ah
print8	label	proc
	call	$+5
	ror	al,4
	push	eax
	and	al,0fh
	cmp	al,0ah
	sbb	al,69h
	das
	push	eax
	mov	ecx,esp
	summon	GetStdHandle, STD_OUTPUT_HANDLE
	summon	WriteFile, eax,ecx,1,esp,NULL
	pop	eax
	pop	eax
	retn

print	endp

endif

END_CODE

	end
