; M E T A X P O N   a u d i o	t i m e - s c a l i n g   l i b r a r y
;
; FPU Edition
; Supports single precision floating point data

CPU 486

%define real4	4
%define real8	8

%ifidn __OUTPUT_FORMAT__,win32
  %define CONST     section .rdata
%elifidn __OUTPUT_FORMAT__,elf
  %define CONST     section .rodata
%else
  %define CONST     section .data
%endif

section .text

; Fast Fourier Transform
;
fft:
    %push mycontext
    %stacksize flat
    %arg Array:dword, FrameBit:dword, sign:dword
    %assign %$localsize 0
;   %local step_r:qword, step_i:qword, half:dword   <- qword offsets wrong!
    %local pad1:dword, step_r:dword, pad2:dword, step_i:dword, half:dword

    push   ebp
    mov    ebp,esp
    add    esp,byte -%$localsize
    push   ebx
    push   ecx
    push   edx
    push   esi
    push   edi
		fld1
		fld1
		fadd	st0,st0
		fdivp	st1,st0
		fstp	dword [half]

		mov	cl,byte [FrameBit]
		mov	eax,2*real4
		mov	esi,eax 		; i=1  (*2*real4)
		sal	eax,cl
		mov	ebx,[Array]
		mov	ecx,eax
		mov	edx,eax
		mov	edi,eax
		sub	ecx,esi 		; FrameSize-1 (*2*real4)
		add	eax,ebx
		shr	edi,1			; j=FrameSize/2 (*2*real4)
		push	eax			; ArrayEnd

		test	byte [sign+3],80h
		jnz	near fft_inverse

copy_reverse:	cmp	esi,edi
		jnb	bit_reverse

		fld	dword [esi+ebx]
		fld	dword [esi+ebx+real4]
		fld	dword [edi+ebx]
		fld	dword [edi+ebx+real4]
		fstp	dword [esi+ebx+real4]
		fstp	dword [esi+ebx]
		fstp	dword [edi+ebx+real4]
		fstp	dword [edi+ebx]

bit_reverse:	mov	eax,edx
bit_reverse1:	shr	eax,1
		sub	edi,eax
		jnb	bit_reverse1
		add	edi,eax
		add	edi,eax

		add	esi,byte 2*real4
		cmp	esi,ecx
		jne	copy_reverse


		pop	edi

first_k:	fld	dword [ebx+2*2*real4]		; R[i+2]
		fld	st0
		fld	dword [ebx+3*2*real4]		; R[i+3]
		fsub	st2,st0 			; r.i = R[i+2] - R[i+3]
		faddp	st1,st0 			; e.r = R[i+2] + R[i+3]
		fld	st0				; e.r
		fld	dword [ebx]			; R[i]
		fld	st0
		fld	dword [ebx+1*2*real4]		; R[i+1]
		fadd	st2,st0 			; q.r = R[i] + R[i+1]
		fsubp	st1,st0 			; w.r = R[i] - R[i+1]
		fld	dword [ebx+2*2*real4+real4]	; I[i+2]
		fst	st6
		fld	dword [ebx+3*2*real4+real4]	; I[i+3]
		fadd	st7,st0 			; e.i =  I[i+2] + I[i+3]
		fsubrp	st1,st0 			; r.r = -I[i+2] + I[i+3]

		fld	st0				; r.r
		fadd	st0,st2 			; R[i+1] = w.r + r.r
		fstp	dword [ebx+1*2*real4]		; R[i+1]
		fsubp	st1,st0 			; R[i+3] = w.r - r.r
		fstp	dword [ebx+3*2*real4]		; R[i+3]
		fsubr	st2,st0 			; R[i+2] = q.r - e.r
		faddp	st1,st0 			; R[i]	 = q.r + e.r
		fstp	dword [ebx]			; R[i]
		fstp	dword [ebx+2*2*real4]		; R[i+2]

		fld	st0				; r.i
		fld	dword [ebx+real4]		; I[i]
		fld	st0
		fld	dword [ebx+1*2*real4+real4]	; I[i+1]
		fsub	st2,st0 			; w.i = I[i] - I[i+1]
		faddp	st1,st0 			; q.i = I[i] + I[i+1]
		fld	st0				; q.i
		fadd	st0,st5 			; I[i]	 = q.i + e.i
		fstp	dword [ebx+real4]		; I[i]
		fsubrp	st4,st0 			; I[i+2] = q.i - e.i
		fsubr	st2,st0 			; I[i+3] = w.i - r.i
		faddp	st1,st0 			; I[i+1] = w.i + r.i
		fstp	dword [ebx+1*2*real4+real4]	; I[i+1]
		fstp	dword [ebx+3*2*real4+real4]	; I[i+3]
		fstp	dword [ebx+2*2*real4+real4]	; I[i+2]

		add	ebx,byte 4*2*real4
		cmp	ebx,edi
		jb	first_k

		jmp	composition


fft_inverse:	fild	dword [FrameBit]
		fchs
		fld1
		fscale

copy_reverse_i: cmp	esi,edi
		ja	bit_reverse_i

		fld	dword [esi+ebx]
		fmul	st0,st1
		fld	dword [esi+ebx+real4]
		fmul	st0,st2
		fld	dword [edi+ebx]
		fmul	st0,st3
		fld	dword [edi+ebx+real4]
		fmul	st0,st4
		fstp	dword [esi+ebx+real4]
		fstp	dword [esi+ebx]
		fstp	dword [edi+ebx+real4]
		fstp	dword [edi+ebx]

bit_reverse_i:	mov	eax,edx
bit_reverse1_i: shr	eax,1
		sub	edi,eax
		jnb	bit_reverse1_i
		add	edi,eax
		add	edi,eax

		add	esi,byte 2*real4
		cmp	esi,ecx
		jne	copy_reverse_i

		fld	dword [+ebx]
		fmul	st0,st1
		fld	dword [ebx+real4]
		fmul	st0,st2
		fstp	dword [ebx+real4]
		fstp	dword [ebx]

		fld	dword [esi+ebx]
		fmul	st0,st1
		fld	dword [esi+ebx+real4]
		fmulp	st2,st0
		fstp	dword [esi+ebx]
		fstp	dword [esi+ebx+real4]


		pop	edi

first_k_inv:	fld	dword [ebx+2*2*real4]		; R[i+2]
		fld	st0
		fld	dword [ebx+3*2*real4]		; R[i+3]
		fsubr	st2,st0 			; r.i = -R[i+2] + R[i+3]
		faddp	st1,st0 			; e.r =  R[i+2] + R[i+3]
		fld	st0				; e.r
		fld	dword [ebx]			; R[i]
		fld	st0
		fld	dword [ebx+1*2*real4]		; R[i+1]
		fadd	st2,st0 			; q.r = R[i] + R[i+1]
		fsubp	st1,st0 			; w.r = R[i] - R[i+1]
		fld	dword [ebx+2*2*real4+real4]	; I[i+2]
		fst	st6
		fld	dword [ebx+3*2*real4+real4]	; I[i+3]
		fadd	st7,st0 			; e.i = I[i+2] + I[i+3]
		fsubp	st1,st0 			; r.r = I[i+2] - I[i+3]

		fld	st0				; r.r
		fadd	st0,st2 			; R[i+1] = w.r + r.r
		fstp	dword [ebx+1*2*real4]		; R[i+1]
		fsubp	st1,st0 			; R[i+3] = w.r - r.r
		fstp	dword [ebx+3*2*real4]		; R[i+3]
		fsubr	st2,st0 			; R[i+2] = q.r - e.r
		faddp	st1,st0 			; R[i]	 = q.r + e.r
		fstp	dword [ebx]			; R[i]
		fstp	dword [ebx+2*2*real4]		; R[i+2]

		fld	st0				; r.i
		fld	dword [ebx+real4]		; I[i]
		fld	st0
		fld	dword [ebx+1*2*real4+real4]	; I[i+1]
		fsub	st2,st0 			; w.i = I[i] - I[i+1]
		faddp	st1,st0 			; q.i = I[i] + I[i+1]
		fld	st0				; q.i
		fadd	st0,st5 			; I[i]	 = q.i + e.i
		fstp	dword [ebx+real4]		; I[i]
		fsubrp	st4,st0 			; I[i+2] = q.i - e.i
		fsubr	st2,st0 			; I[i+3] = w.i - r.i
		faddp	st1,st0 			; I[i+1] = w.i + r.i
		fstp	dword [ebx+1*2*real4+real4]	; I[i+1]
		fstp	dword [ebx+3*2*real4+real4]	; I[i+3]
		fstp	dword [ebx+2*2*real4+real4]	; I[i+2]

		add	ebx,byte 4*2*real4
		cmp	ebx,edi
		jb	first_k_inv


composition:	fldpi
		fmul	dword [half]
		fmul	dword [half]	; pi/4
		mov	eax,4*2*real4	; CurBlockSize (cbs) = 4
		mov	esi,eax
		mov	edx,[FrameBit]
		sub	edx,byte 2	; k

k_loop: 	add	eax,eax 	; CurBlockSize*2
		mov	ebx,[Array]	; i=0
		mov	ecx,2*real4	; j=1

first_i_loop:	fld	dword [ebx]		; R[i]
		fld	dword [ebx+real4]	; I[i]
		fld	dword [esi+ebx] 	; R[i+cbs]
		fld	dword [esi+ebx+real4]	;I[i+cbs]
		fld	st3			; R[i]
		fld	st3			; I[i]
		fsub	st0,st2 		; I[i]-I[i+cbs]
		fstp	dword [esi+ebx+real4]	; I[i+cbs] = I[i]-I[i+cbs]
		fsub	st0,st2 		; R[i]-R[i+cbs]
		fstp	dword [esi+ebx] 	; R[i+cbs] = R[i]-R[i+cbs]
		faddp	st2,st0 		; I[i]+I[i+cbs]
		faddp	st2,st0 		; R[i]+R[i+cbs]
		fstp	dword [ebx+real4]	; I[i] = I[i]+I[i+cbs]
		fstp	dword [ebx]		; R[i] = R[i]+R[i+cbs]

		add	ebx,eax
		cmp	ebx,edi
		jb	first_i_loop

		fst	st1		; pi/CurBlockSize
		fsincos
		fst	qword [step_r]	; shift_r
		fxch
		fimul	dword [sign]
		fst	qword [step_i]	; shift_i
		jmp	short j_loop_entry

j_loop: 	fld	qword [step_r]
		fld	qword [step_i]
		fld	st1		; step_r
		fmul	st0,st4 	; step_r*shift_r
		fld	st1		; step_i
		fmul	st0,st4 	; step_i*shift_i
		fsubp	st1,st0 	; shift_r*step_r - shift_i*step_i

		fxch	st4		; shift_r
		fmulp	st1,st0 	; shift_r*step_i
		fxch	st2		; shift_i
		fmulp	st1,st0 	; shift_i*step_r
		faddp	st1,st0 	; shift_r*step_i + shift_i*step_r

j_loop_entry:	mov	ebx,ecx 	; i=j
		add	ebx,[Array]

i_loop: 	fld	dword [esi+ebx] 	; R[i+cbs]
		fld	dword [esi+ebx+real4]	; I[i+cbs]
		fld	st3			; shift_r
		fmul	st0,st2 		; R[i+cbs]*shift_r
		fld	st3			; shift_i
		fmul	st0,st2 		; I[i+cbs]*shift_i
		fsubp	st1,st0 		; tr = R[i+cbs]*shift_r - I[i+cbs]*shift_i

		fxch	st2			; R[i+cbs]
		fmul	st0,st3 		; R[i+cbs]*shift_i
		fxch				; I[i+cbs]
		fmul	st0,st4 		; I[i+cbs]*shift_r
		faddp	st1,st0 		; ti = R[i+cbs]*shift_i + I[i+cbs]*shift_r

		fld	dword [ebx]		; R[i]
		fld	dword [ebx+real4]	; I[i]
		fld	st3			; tr
		fsubr	st0,st2 		; R[i]-tr
		fstp	dword [esi+ebx] 	; R[i+cbs] = R[i]-tr
		fld	st2			; ti
		fsubr	st0,st1 		; I[i]-ti
		fstp	dword [esi+ebx+real4]	; I[i+cbs] = I[i]-ti

		faddp	st2,st0 		; ti+I[i]
		faddp	st2,st0 		; tr+R[i]
		fstp	dword [ebx+real4]	; I[i] = I[i]+ti
		fstp	dword [ebx]		; R[i] = R[i]+tr

		add	ebx,eax
		cmp	ebx,edi
		jb	i_loop

		add	ecx,byte 2*real4
		cmp	ecx,esi
		jb	j_loop

		fcompp
		fmul	dword [half]

		mov	esi,eax
		dec	edx
		jnz	k_loop

		fstp	st0
;;;		ret
    pop    edi
    pop    esi
    pop    edx
    pop    ecx
    pop    ebx
    leave
    ret    3*4
    %pop


; Vocode - Phase modifications
; FPU must be initialized to round_to_nearest or round_to_even mode!
;
CONST

%include "vocbufp.i"

ATTACK_LOCK	    EQU     4	    ; Blocks after attack that can't have attack
ATTACK_BLOCK	    EQU     1	    ; Number of successive blocks with unchanged input phase
ATTACK_AMPLIFY	    EQU     1	    ; 1-Use attack amplification, 0-Don't use
%define ATTACK_AMP_LEVEL    1.4     ; Level of amplification
ATTACK_TEMPO_LOCK   EQU     0	    ; Number of successive blocks with tempo locked to 100%
ATTACK_PHASE_BLOCK  EQU     ATTACK_LOCK - ATTACK_BLOCK
ATTACK_TEMPO_BLOCK  EQU     ATTACK_LOCK - ATTACK_TEMPO_LOCK

align 4
FFTsize dd	FFTSIZE*real4
%if HOPSIZE==1024
  H0PSIZE dd	1024.		    ; FFTSIZE/OVERSAMP
%elif HOPSIZE==512
  H0PSIZE dd	 512.
%elif HOPSIZE==256
  H0PSIZE dd	 256.
%else
  %error Bad HOPSIZE value!
%endif

section .text

Vocode:
    %push mycontext
    %stacksize flat
    %arg MagnS:dword, Real:dword, Imag:dword, OldInPhase:dword, OutPhase:dword,\
	 Peak:dword, InStep:dword, Energy:dword, Attack:dword, Level:dword
    %assign %$localsize 0
    %local OldPeak:dword, MinV:dword, MinI:dword, temp_i:dword, attack_flag:byte

    push   ebp
    mov    ebp,esp
    add    esp,byte -%$localsize
		pushad

		mov	eax,[Energy]
		xor	ebx,ebx
		mov	ecx,[eax]		; Energy[0]
		mov	edx,[eax+real4] 	; Energy[1]
		mov	[eax+real4],ecx 	; Energy[1]=Energy[0]
		mov	[eax+2*real4],edx	; Energy[2]=Energy[1]
		mov	[OldPeak],ebx		; OldPeak=0
		mov	[MinI],ebx		; MinI=0

		mov	ecx,[MagnS]
		mov	esi,[Real]
		mov	edi,[Imag]

		fldz
;;;		.repeat
@C0001:
			fld	dword [ebx+esi]      ; Real[i]
			fmul	st0,st0
			fld	dword [ebx+edi]      ; Imag[i]
			fmul	st0,st0
			faddp	st1,st0
			fst	dword [ebx+ecx]      ; MagnS[i]
			faddp	st1,st0
			add	ebx,byte real4
;;;		.until ebx > FFTSIZE/2*real4
    cmp    ebx, FFTSIZE / 002h * real4
    jbe    @C0001
		fstp	dword [eax]		; Energy[0]

		mov	edx,[ecx]		; MagnS[0]
		mov	[MinV],edx

		mov	ecx,[Attack]
		mov	dl,[ecx]
		dec	dl
		jns	write_Attack

		mov	ebx,[eax+real4] 	; Energy[1]
		cmp	[eax],ebx		; Energy[0]
		jna	condition
		cmp	[eax+2*real4],ebx	; Energy[2]
		jnb	condition
		fld	dword [eax+2*real4]	; Energy[2]
		fmul	dword [Level]
		fcomp	dword [eax]		; Energy[0]
		fnstsw	ax
		sahf
		jnb	condition

		mov	dl,ATTACK_LOCK
write_Attack:	mov	[ecx],dl

condition:	mov	al,ATTACK_PHASE_BLOCK
		sub	al,dl
		mov	[attack_flag],al

		mov	eax,[OutPhase]
		mov	ebx,[OldInPhase]
;;;		.if byte ptr [esi+real4-1] & 80h
    test   byte [esi + real4 - 001h], 080h
    je	   @C0003
			fldpi
;;;		.else
    jmp    short @C0005
@C0003:
			fldz
;;;		.endif
@C0005:
		fst	dword [eax]
		fstp	dword [ebx]

		fild	dword [FFTsize]
		fld1
		fldpi
		fadd	st0,st0 		; 2*Pi
		fdiv	st1,st0 		; 1/(2*Pi)
		fdivr	st2,st0 		; 2*PI/FFTSIZE/real4
		fld1
		fidiv	dword [InStep]		; 1/InStep

		mov	ebx,2*real4		; i=2
;;;		.repeat
@C0006:
			mov	ecx,[MagnS]
			mov	eax,[ebx+ecx]		; MagnS[i]
			mov	edx,[MinV]
			sub	eax,edx
			sbb	ecx,ecx
			and	eax,ecx
			not	ecx
			add	eax,edx
			mov	[MinV],eax
			mov	edx,[MinI]
			sub	edx,ebx
			and	ecx,edx
			add	ecx,ebx
			mov	[MinI],ecx

			mov	[temp_i],ebx
			add	ebx,[MagnS]
			mov	eax,[ebx-2*real4]	; MagnS[i-2]
			mov	edx,[ebx-1*real4]	; MagnS[i-1]
			sub	eax,edx
			sbb	ecx,ecx
			not	ecx
			and	eax,ecx
			add	eax,edx

			mov	edx,[ebx+1*real4]	; MagnS[i+1]
			sub	eax,edx
			sbb	ecx,ecx
			not	ecx
			and	eax,ecx
			add	eax,edx

			mov	edx,[ebx+2*real4]	; MagnS[i+2]
			sub	eax,edx
			sbb	ecx,ecx
			not	ecx
			and	eax,ecx
			add	eax,edx

			cmp	eax,[ebx]		; MagnS[i]
			mov	ebx,[temp_i]
;;;			.if carry?			; eax < [ebx]
    jae    near @C0007
				fld	dword [ebx+edi] 	; Imag[i]
				fld	dword [ebx+esi] 	; Real[i]
				fpatan				; InPhase
				mov	ecx,[OldInPhase]
				mov	edx,[OutPhase]

;;;				.if attack_flag & 80h
    test   byte [attack_flag], 080h
    je	   @C0009
					fst	dword [edx+ebx] 	; OutPhase[i]
;;;				.else
    jmp    short @C000B
@C0009:
					fild	dword [temp_i]
					mov	eax,[Peak]
					fmul	st0,st5 		; i*2*PI/FFTSIZE
					fild	dword [InStep]
					mov	eax,[ebx+eax]		; Peak[i]
					fmul	st0,st1 		; InStep*i*2*PI/FFTSIZE

					fld	st2			; InPhase
					fsub	dword [ecx+eax] 	; OldInPhase[Peak[i]]

					fsubrp	st1,st0

					fmul	st0,st5 		; / (2*Pi)
					fld	st0
					frndint
					fsubp	st1,st0
					fmul	st0,st4 		; Delta

					fmul	st0,st3 		; Delta/InStep
					faddp	st1,st0 		; i*2*PI/FFTSIZE + Delta/InStep
					fmul	dword [H0PSIZE]
					fadd	dword [edx+eax] 	; OutPhase[Peak[i]]

					fmul	st0,st4 		; / (2*Pi)
					fld	st0
					frndint
					fsubp	st1,st0
					fmul	st0,st3 		; * (2*Pi)
					fstp	dword [edx+ebx] 	; OutPhase[i]
;;;				.endif
@C000B:
				fstp	dword [ecx+ebx] 	; OldInPhase[i]

				mov	eax,[Peak]
				mov	ecx,[OldPeak]		; j
				mov	edx,ecx 		; OldPeak
;;;				.while ecx <= MinI		; Mark peaks I
    jmp    short @C000C
@C000D:
					mov	[ecx+eax],edx		; Peak[j] = OldPeak
					add	ecx,byte real4
;;;				.endw
@C000C:
    cmp    ecx, [MinI]
    jbe    @C000D

				mov	[OldPeak],ebx		; OldPeak = i
;;;				.while ecx < ebx		; Mark peaks II
    jmp    short @C000F
@C0010:
					mov	[ecx+eax],ebx		; Peak[j] = OldPeak
					add	ecx,byte real4
;;;				.endw
@C000F:
    cmp    ecx, ebx
    jb	   @C0010

				mov	ecx,[MagnS]
				mov	eax,[ebx+ecx]		; MagnS[i]
				mov	[MinI],ebx
				mov	[MinV],eax
;;;			.endif
@C0007:
			add	ebx,byte real4
;;;		.until ebx == real4*(FFTSIZE/2-1)
    cmp    ebx, real4 * ( FFTSIZE / 002h - 001h )
    jne    @C0006
		fcompp
		fcompp

		mov	eax,[Peak]
		mov	ecx,[OldPeak]		; j
		mov	edx,ecx 		; OldPeak
;;;		.while ecx < FFTSIZE/2*real4	; Mark peaks III
    jmp    short @C0013
@C0014:
			mov	[ecx+eax],edx		; Peak[j] = OldPeak
			add	ecx,byte real4
;;;		.endw
@C0013:
    cmp    ecx, FFTSIZE / 002h * real4
    jb	   @C0014

		mov	ecx,[OldInPhase]
		mov	ebp,[OutPhase]
		or	edx,byte -1		; CurPeak
		fldz				; zi=0
		fld1				; zr=1
		mov	ebx,1*real4		; i
;;;		.repeat
@C0016:
;;;			.if edx != [eax+ebx]
    cmp    edx, [ebx + eax]
    je	   @C0017
				mov	edx,[ebx+eax]
				fstp	st0
				fstp	st0
				fld	dword [edx+ebp] 	; OutPhase[CurPeak]
				fsub	dword [edx+ecx] 	; OldInPhase[CurPeak]
				fsincos
;;;			.endif

@C0017:
			fld	dword [esi+ebx]      ; Real[i]
			fld	dword [edi+ebx]      ; Imag[i]
			fld	st1
			fld	st1
			fmul	st0,st5
			fxch
			fmul	st0,st4
			fsubrp	st1,st0
			fstp	dword [esi+ebx]      ; new Real[i]
			fmul	st0,st2
			fxch
			fmul	st0,st3
			faddp	st1,st0
			fstp	dword [edi+ebx]      ; new Imag[i]
			add	ebx,byte real4
;;;		.until ebx >= FFTSIZE/2*real4
    cmp    ebx, FFTSIZE / 002h * real4
    jb	   @C0016

		fcompp
		popad
;;;		ret
    leave
    ret
    %pop


; VocProcess - Main vocoder function
;
CONST

align 4
%if FLOAT_DATA = 0
 max		 dd	 32767.0
 min		 dd	-65536.0
 quarter	 dd	 0.25
%endif
normalize	 dd	 0.0000152587890625	; 1/65536
 %if ATTACK_AMPLIFY
attack_amp_const dd	ATTACK_AMP_LEVEL
 %endif

section .text

%ifdef static
  %if PRO
	%define  VocProcess_fpu  MXprocess_fpu_pro
	%define _VocProcess_fpu _MXprocess_fpu_pro
  %else
	%define  VocProcess_fpu  MXprocess_fpu
	%define _VocProcess_fpu _MXprocess_fpu
  %endif
%endif

global	VocProcess_fpu
global _VocProcess_fpu
 VocProcess_fpu:
_VocProcess_fpu:
    %push mycontext
    %stacksize flat
    %arg vb:dword
    %assign %$localsize 0
    %local InStep:dword, OldInBuffOfs:dword, j:dword

    push   ebp
    mov    ebp,esp
    add    esp,byte -%$localsize
    push   ebx
    push   ecx
    push   edx
    push   esi
    push   edi
	mov	esi,[vb]
	mov	al,[esi+VB.E0F]
;;;	.if al && !(al & 40h)
    or	al, al
    je	   @C001A
    test   al, 040h
    jne    @C001A
		and	eax,byte 11b
		dec	eax
		neg	eax
		mov	ecx,[esi+VB.InBlkSz]
		mov	edx,[esi+VB.Last]
		and	eax,ecx
		mov	edi,[esi+VB.InBuff]
		add	edi,eax
		add	edi,edx
		sub	ecx,edx
		shr	ecx,2
		xor	eax,eax
		rep	stosd
		or	byte [esi+VB.E0F],40h
;;;	.endif
@C001A:

	mov	eax,[esi+VB.Speed]
%if (InStep_shift-1) < 7
	add	eax,byte 1 << (InStep_shift-1)	; Round
%else
	add	eax,1 << (InStep_shift-1)	; Round
%endif
	shr	eax,InStep_shift		; * HOPSIZE/10000h
	mov	[InStep],eax

	mov	eax,[esi+VB.InBuffOfs]
	mov	[OldInBuffOfs],eax

	xor	eax,eax 			; j=0
;;;	.repeat
@C001D:
		mov	[j],eax
		mov	ebx,[esi+VB.InBuffOfs]
		mov	edx,[esi+VB.InBuff]
		add	ebx,ebx 			; * word
%if FLOAT_DATA
		add	ebx,ebx 			; * real4
%endif
		mov	eax,[esi+VB.Comp]
		mov	ecx,[esi+VB.Window]
		xor	edi,edi 			; i=0
;;;		.repeat
@C001E:
%if FLOAT_DATA
			fld	dword [ebx+edx] 		; *(ib)
			fld	dword [ebx+edx+real4]		; *(ib+1)
%else
			fild	word [ebx+edx]			; *(ib)
			fild	word [ebx+edx+2]		; *(ib+1)
%endif
			fld	dword [edi+ecx] 		; Window[i]
			add	ebx,byte SAMPLESIZE		; ib++; ib++
			fmul	st1,st0
			fmulp	st2,st0
			and	ebx,[esi+VB.QuadInBlSamsk]	; % (4*INBLOCKSAM)
			fstp	dword [eax+2*edi+real4] 	; Comp[i].i
			fstp	dword [eax+2*edi]		; Comp[i].r
 %if PRO
			mov	dword [eax+2*edi+FFTSIZE*real4],0
			mov	dword [eax+2*edi+FFTSIZE*real4+real4],0
 %endif
			add	edi,byte real4			; i++
;;;		.until edi == FFTSIZE*real4 shr PRO
    cmp    edi, FFTSIZE * real4 >> PRO
    jne    @C001E

;;;		invoke	fft, eax,FFTBITS,-1
    push   byte -1
    push   byte FFTBITS
    push   eax
    call   fft

		mov	eax,[esi+VB.Comp]
		mov	ebx,real4			; i=1
		mov	ecx,[esi+VB.RealA]
		mov	edx,[esi+VB.ImagA]
		mov	edi,[esi+VB.ImagB]
		mov	esi,[esi+VB.RealB]
;;;		.repeat
@C0020:
			fld	dword [eax+2*ebx]		; Comp[i].r
			fld	dword [eax+2*ebx+real4] 	; Comp[i].i
			neg	ebx
			fld	st1
			fld	st1
			fld	dword [eax+2*real4*FFTSIZE+2*ebx+real4] ; Comp[FFTSIZE-i].i
			fld	dword [eax+2*real4*FFTSIZE+2*ebx]	; Comp[FFTSIZE-i].r
			neg	ebx
			fsubr	st5,st0
			faddp	st3,st0
			fadd	st3,st0
			fsubp	st1,st0
			fstp	dword [ebx+edx] 		; ImagA[i]
			fstp	dword [ebx+ecx] 		; RealA[i]
			fstp	dword [ebx+esi] 		; RealB[i]
			fstp	dword [ebx+edi] 		; ImagB[i]
			add	ebx,byte real4			; i++
;;;		.until ebx == FFTSIZE/2*real4
    cmp    ebx, FFTSIZE / 002h * real4
    jne    @C0020
		fld	dword [eax]			; Comp[0].r
		fld	dword [eax+real4]		; Comp[0].i
		fld	dword [eax+2*ebx]		; Comp[FFTSIZE/2].r
		fld	dword [eax+2*ebx+real4] 	; Comp[FFTSIZE/2].i
		fldz
		fst	dword [edx]			; ImagA[0]
		fst	dword [edi]			; ImagB[0]
		fst	dword [ebx+edx] 		; ImagA[FFTSIZE/2]
		fstp	dword [ebx+edi] 		; ImagB[FFTSIZE/2]
		fadd	st0,st0
		fstp	dword [ebx+esi] 		; RealB[FFTSIZE/2]
		fadd	st0,st0
		fstp	dword [ebx+ecx] 		; RealA[FFTSIZE/2]
		fadd	st0,st0
		fstp	dword [esi]			; RealB[0]
		fadd	st0,st0
		fstp	dword [ecx]			; RealA[0]

		mov	esi,[vb]
		fild	dword [esi+VB.Threshold]
		fmul	dword [normalize]
		push	eax
		fstp	dword [esp]

		lea	eax,[esi+VB.AttackL]
		push	eax
		push	dword [esi+VB.EnergyL]
		push	dword [InStep]
		push	dword [esi+VB.PeakL]
		push	dword [esi+VB.OutPhaseL]
		push	dword [esi+VB.OldInPhaseL]
		push	dword [esi+VB.ImagA]
		push	dword [esi+VB.RealA]
		push	dword [esi+VB.MagnS]
		call	Vocode
		add	esp,byte 9*4

		lea	eax,[esi+VB.AttackR]
		push	eax
		push	dword [esi+VB.EnergyR]
		push	dword [InStep]
		push	dword [esi+VB.PeakR]
		push	dword [esi+VB.OutPhaseR]
		push	dword [esi+VB.OldInPhaseR]
		push	dword [esi+VB.ImagB]
		push	dword [esi+VB.RealB]
		push	dword [esi+VB.MagnS]
		call	Vocode
		add	esp,byte 10*4

		mov	eax,[esi+VB.Comp]
		mov	ebx,real4			; i=1
		mov	ecx,[esi+VB.RealA]
		mov	edx,[esi+VB.ImagA]
	;	mov	edi,[esi+VB.ImagB]
		mov	esi,[esi+VB.RealB]
;;;		.repeat
@C0022:
			fld	dword [ebx+esi] 	; RealB[i]
			fld	dword [ebx+ecx] 	; RealA[i]
			fld	st1
			fld	st1
			fld	dword [ebx+edi] 	; ImagB[i]
			fld	dword [ebx+edx] 	; ImagA[i]
			fsub	st5,st0
			faddp	st3,st0
			fadd	st3,st0
			fsubp	st1,st0
			fstp	dword [eax+2*ebx]	; Comp[i].r
			fstp	dword [eax+2*ebx+real4] ; Comp[i].i
			neg	ebx
			fstp	dword [eax+2*real4*FFTSIZE+2*ebx]	; Comp[FFTSIZE-i].r
			fstp	dword [eax+2*real4*FFTSIZE+2*ebx+real4] ; Comp[FFTSIZE-i].i
			neg	ebx
			add	ebx,byte real4		; i++
;;;		.until ebx == FFTSIZE/2*real4
    cmp    ebx, FFTSIZE / 002h * real4
    jne    @C0022
		fld	dword [ebx+esi] 		; RealB[FFTSIZE/2]
		fld	dword [ebx+ecx] 		; RealA[FFTSIZE/2]
		fld	dword [esi]			; RealB[0]
		fld	dword [ecx]			; RealA[0]
		fadd	st0,st0
		fstp	dword [eax]			; Comp[0].r
		fadd	st0,st0
		fstp	dword [eax+real4]		; Comp[0].i
		fadd	st0,st0
		fstp	dword [eax+2*ebx]		; Comp[FFTSIZE/2].r
		fadd	st0,st0
		fstp	dword [eax+2*ebx+real4] 	; Comp[FFTSIZE/2].i

;;;		invoke	fft, eax,FFTBITS,1
    push   byte 1
    push   byte FFTBITS
    push   eax
    call   fft

 %if ATTACK_AMPLIFY
		mov	esi,[vb]
		mov	ebx,[esi+VB.OutBuffOfs]
		mov	ecx,[esi+VB.OutL]
		mov	edx,[esi+VB.OutR]

		mov	eax,[esi+VB.AttackL]		; "AttackL" & "AttackR" together! (both are WORDs)
		mov	edi,ATTACK_PHASE_BLOCK*10000h+ATTACK_PHASE_BLOCK
		sub	edi,eax 			; Do SIMD style comparison
		and	edi,0FFF0FFF0h			;
;;;		.if zero?
    jne    @C0024
			mov	eax,[esi+VB.Comp]
			mov	esi,[esi+VB.Window]
;;;			.repeat
@C0026:
				and	ebx,(FFTSIZE-1)*real4		; % FFTSIZE
				fld	dword [eax+2*edi]		; Comp[i].r
				fld	dword [eax+2*edi+real4] 	; Comp[i].i
				fld	dword [edi+esi] 		; Window[i]
				fmul	st1,st0
				fmulp	st2,st0
				fadd	dword [ebx+edx] 		; OutR[(OutBuffOfs+i)%FFTSIZE]
				fstp	dword [ebx+edx] 		;
				fadd	dword [ebx+ecx] 		; OutL[(OutBuffOfs+i)%FFTSIZE]
				fstp	dword [ebx+ecx] 		;
				add	edi,byte real4			; i++
				add	ebx,byte real4
;;;			.until edi == FFTSIZE*real4 shr PRO
    cmp    edi, FFTSIZE * real4 >> PRO
    jne    @C0026
;;;		.else
    jmp    short @C0028
@C0024:
			fld	dword [attack_amp_const]
			fld	st0
			sub	eax,(ATTACK_PHASE_BLOCK+1)*10000h+(ATTACK_PHASE_BLOCK+1)
			and	eax,0FFF0FFF0h				; Another SIMD style comparison
;;;			.if !zero?
    je	   @C0029
				fld1
				fstp	st1				; Attack in left channel
;;;				.if ax
    or	ax, ax
    je	   @C002B
					fxch				; Attack in right channel
;;;				.endif
;;;			.endif
@C002B:
@C0029:
			mov	eax,[esi+VB.Comp]
			mov	esi,[esi+VB.Window]
			xor	edi,edi 			; i=0
;;;			.repeat
@C002D:
				and	ebx,(FFTSIZE-1)*real4		; % FFTSIZE
				fld	dword [eax+2*edi]		; Comp[i].r
				fmul	st0,st2
				fld	dword [eax+2*edi+real4] 	; Comp[i].i
				fmul	st0,st2
				fld	dword [edi+esi] 		; Window[i]
				fmul	st1,st0
				fmulp	st2,st0
				fadd	dword [ebx+edx] 		; OutR[(OutBuffOfs+i)%FFTSIZE]
				fstp	dword [ebx+edx] 		;
				fadd	dword [ebx+ecx] 		; OutL[(OutBuffOfs+i)%FFTSIZE]
				fstp	dword [ebx+ecx] 		;
				add	edi,byte real4			; i++
				add	ebx,byte real4
;;;			.until edi == FFTSIZE*real4 shr PRO
    cmp    edi, FFTSIZE * real4 >> PRO
    jne    @C002D
			fcompp
;;;		.endif
 %else
		mov	esi,[vb]
		mov	eax,[esi+VB.Comp]
		mov	ebx,[esi+VB.OutBuffOfs]
		mov	ecx,[esi+VB.OutL]
		mov	edx,[esi+VB.OutR]
		mov	esi,[esi+VB.Window]
		xor	edi,edi 			; i=0
;;;		.repeat
@C0024a:
			and	ebx,(FFTSIZE-1)*real4		; % FFTSIZE
			fld	dword [eax+2*edi]		; Comp[i].r
			fld	dword [eax+2*edi+real4] 	; Comp[i].i
			fld	dword [edi+esi] 		; Window[i]
			fmul	st1,st0
			fmulp	st2,st0
			fadd	dword [ebx+edx] 		; OutR[(OutBuffOfs+i)%FFTSIZE]
			fstp	dword [ebx+edx] 		;
			fadd	dword [ebx+ecx] 		; OutL[(OutBuffOfs+i)%FFTSIZE]
			fstp	dword [ebx+ecx] 		;
			add	edi,byte real4			; i++
			add	ebx,byte real4
;;;		.until edi == FFTSIZE*real4 shr PRO
    cmp    edi, FFTSIZE * real4 >> PRO
    jne    @C0024a
 %endif
@C0028:
		mov	esi,[vb]
		mov	eax,[j]
		movzx	edi,byte [esi+VB.LastFilledBuf]
		mov	ebx,[esi+VB.OutBuffOfs]
%if FLOAT_DATA
		shl	eax,HOPSIZE_shift+3		; 2*HOPSIZE*j
%else
		shl	eax,HOPSIZE_shift+2		; 2*HOPSIZE*j
%endif
		imul	edi,[esi+VB.OutBlkSz]		; LastFilledBuf*OUTBLOCKSAM*2
		add	edi,eax 			; LastFilledBuf*OUTBLOCKSAM*2+2*HOPSIZE*j
		xor	eax,eax 			; i=0
		add	edi,[esi+VB.OutBuff]		; OutBuff+LastFilledBuf*OUTBLOCKSAM*2+2*HOPSIZE*j
;;;		.repeat
@C002F:
			fld	dword [ebx+edx] 	     ; OutR[OutBuffOfs+i]
			fld	dword [ebx+ecx] 	     ; OutL[OutBuffOfs+i]
%if FLOAT_DATA
			fstp	dword [eax+edi] 	     ; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i]
			fstp	dword [eax+edi+real4]	     ; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i + 1]
%else
			fld	st1
			fld	st1
			fld	dword [max]
			fadd	st4,st0
			fadd	st3,st0
			fsub	st1,st0
			fsubp	st2,st0
			fabs
			fsubp	st2,st0
			fabs
			fsubp	st2,st0

			fld	st1
			fld	st1
			fld	dword [min]
			fadd	st4,st0
			fadd	st3,st0
			fsub	st1,st0
			fsubp	st2,st0
			fabs
			faddp	st2,st0
			fabs
			faddp	st2,st0

			fmul	dword [quarter]
			fistp	word [eax+edi]			; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i]
			fmul	dword [quarter]
			fistp	word [eax+edi+2]		; OutBuff[LastFiledBuf*OUTBLOCKSAM*2 + 2*HOPSIZE*j + 2*i + 1]
%endif
			mov	dword [ebx+ecx],0		; OutL[OutBuffOfs+i]=0
			mov	dword [ebx+edx],0		; OutR[OutBuffOfs+i]=0

			add	eax,byte SAMPLESIZE		; i++
			add	ebx,byte real4
;;;		.until eax == HOPSIZE*SAMPLESIZE
    cmp    eax, HOPSIZE * SAMPLESIZE
    jne    @C002F

		and	ebx,(FFTSIZE-1)*real4		; OutBuffOfs=(OutBuffOfs+HOPSIZE)%FFTSIZE
		mov	[esi+VB.OutBuffOfs],ebx

 %if ATTACK_TEMPO_LOCK
		mov	eax,ATTACK_TEMPO_BLOCK*10000h+ATTACK_TEMPO_BLOCK	; Do SIMD style comparison
		mov	ebx,[InStep]
		sub	eax,dword [esi+VB.AttackL]	; "AttackL" & "AttackR" together! (both are WORDs)
		sub	ebx,word HOPSIZE
		and	eax,0FFF0FFF0h
		cmp	eax,1
		sbb	eax,eax
		and	eax,ebx
		add	eax,word HOPSIZE
 %else
		mov	eax,[InStep]
 %endif
		add	eax,eax
		add	eax,[esi+VB.InBuffOfs]		; InBuffOfs += 2*InStep
		and	eax,[esi+VB.QuadInBlSmask]	; InBuffOfs & (4*INBLOCKSAM-1)
		mov	edx,eax
		mov	[esi+VB.InBuffOfs],eax

		mov	cl,[esi+VB.InBlkSamShInc]	; InBuffOfs/(2*INBLOCKSAM)
		shr	eax,cl
	;	and	eax,1
		mov	[esi+VB.Half],al

		inc	eax				; Half + 1
		test	[esi+VB.E0F],al
		jz	@2
			or	byte [esi+VB.E0F],80h
			mov	eax,edx
			and	eax,[esi+VB.DualInBlSmask]	; InBuffOfs & (2*INBLOCKSAM-1)
			add	eax,eax
%if FLOAT_DATA
			add	eax,eax
%endif
			cmp	eax,[esi+VB.Last]		; 2*(InBuffOfs & (2*INBLOCKSAM-1)) >= Last
			jb	@3
			    @1: mov	eax,[j]
				inc	eax
				shl	eax,HOPSIZE_shift
				jmp	short exit
	    @2: test	byte [esi+VB.E0F],80h
		jnz	@1

	    @3: mov	eax,[j]
		inc	eax					; j++
;;;	.until al == [esi].VB.OutBlkHops
    cmp    al, [esi + VB.OutBlkHops]
    jne    @C001D

	xor	edx,[OldInBuffOfs]
;;;	.if edx & [esi].VB.DualInblSam
    test   edx, [esi + VB.DualInblSam]
    je	   @C0032
;;;		.if [esi].VB.E0F
    cmp    byte [esi + VB.E0F], 000h
    je	   @C0034
			mov	al,[esi+VB.Half]
			inc	al
;;;			.if [esi].VB.E0F == al
    cmp    [esi + VB.E0F], al
    jne    @C0036
				mov	edi,[OldInBuffOfs]
				and	edi,[esi+VB.DualInblSam]
				xor	eax,eax
				add	edi,edi 		; * word
%if FLOAT_DATA
				add	edi,edi 		; * real4
%endif
				mov	ecx,[esi+VB.InBlkSz]
				shr	ecx,2			; dword
				add	edi,[esi+VB.InBuff]
				;cld
				rep	stosd
;;;			.endif
;;;		.else
    jmp    short @C0038
@C0034:
			mov	byte [esi+VB.Empty],1
;;;		.endif
;;;	.endif
@C0038:
@C0036:
@C0032:

	or	eax,byte -1
exit:;;;ret
    pop    edi
    pop    esi
    pop    edx
    pop    ecx
    pop    ebx
    leave
    ret
    %pop


; Call before each start of playback

%ifndef nostart

%define  VocStart	 MXstart
%define _VocStart	_MXstart
%ifdef static
  %if PRO
	%define  VocStart  MXstartPro
	%define _VocStart _MXstartPro
  %endif
%endif

global	VocStart
global _VocStart
 VocStart:
_VocStart:
    %push mycontext
    %stacksize flat
    %arg vb:dword

    push   ebp
    mov    ebp, esp
    push   ebx
    push   ecx
    push   edi
		mov	ebx,[vb]
		movzx	eax,byte [ebx+VB.OutBufferSzKB]		; output buffer size [KB]
		mov	ecx,eax
		shr	cl,HOPSIZE_shift+2+FLOAT_DATA-10

;;;		.if al != 2 && al != 4 && al != 8 && al != 16 && al != 32 || !cl
    cmp    al, 002h
    je     @C003B
    cmp    al, 004h
    je     @C003B
    cmp    al, 008h
    je     @C003B
    cmp    al, 010h
    je     @C003B
    cmp    al, 020h
    jne    @C003A
@C003B:
    or	cl, cl
    jne    @C0039
@C003A:
			or	eax,byte -1
				
;;;		.else
    jmp    @C0040
@C0039:
			shl	eax,10
			mov	ecx,eax
			mov	[ebx+VB.OutBlkSz],eax		; Output buffer size [bytes]
			shl	eax,2
			mov	[ebx+VB.InBlkSz],eax		;  Input buffer size [bytes]
			shr	ecx,2+FLOAT_DATA
			mov	eax,ecx				; OUTBLOCKSAM
			shr	ecx,HOPSIZE_shift
			mov	[ebx+VB.OutBlkHops],cl		; OUTBLOCKSAM/HOPSIZE
			shl	eax,3
			mov	[ebx+VB.DualInblSam],eax	;  2*INBLOCKSAM
			bsf	ecx,eax
			mov	[ebx+VB.InBlkSamShInc],cl	;    INBLOCKSAM_shift+1
			dec	eax
			mov	[ebx+VB.DualInBlSmask],eax	;  2*INBLOCKSAM-1 (mask)
			inc	eax
			shl	eax,1
			dec	eax
			mov	[ebx+VB.QuadInBlSmask],eax	;  4*INBLOCKSAM-1 (mask)
			shl	eax,1+FLOAT_DATA
			mov	[ebx+VB.QuadInBlSamsk],eax	; (4*INBLOCKSAM-1)*IODATATYPE (mask)

			;cld
			xor	eax,eax
			mov	edi,[ebx+VB.OutL]
			mov	ecx,FFTSIZE
			rep	stosd
			mov	edi,[ebx+VB.OutR]
			mov	ecx,FFTSIZE
			rep	stosd
			mov	edi,[ebx+VB.OldInPhaseL]
			mov	ecx,FFTSIZE/2
			rep	stosd
			mov	edi,[ebx+VB.OldInPhaseR]
			mov	ecx,FFTSIZE/2
			rep	stosd
			mov	edi,[ebx+VB.OutPhaseL]
			mov	ecx,FFTSIZE/2
			rep	stosd
			mov	edi,[ebx+VB.OutPhaseR]
			mov	ecx,FFTSIZE/2
			rep	stosd
			mov	edi,[ebx+VB.PeakL]
			mov	ecx,FFTSIZE/2
			rep	stosd
			mov	edi,[ebx+VB.PeakR]
			mov	ecx,FFTSIZE/2
			rep	stosd
			mov	[ebx+VB.InBuffOfs],eax
			mov	[ebx+VB.OutBuffOfs],eax
			mov	[ebx+VB.Half],al
			mov	dword [ebx+VB.AttackL],eax	; "AttackL" & "AttackR" together! (both are WORDs)
;;;		.endif
@C0040:

;;;		ret
    pop    edi
    pop    ecx
    pop    ebx
    leave
    ret
    %pop

%endif


; Blackman window initialization

CONST

align 8
minus05 	dq	-0.5
o08		dq	 0.08
o42		dq	 0.42
 %if OVERSAMPBITS-PRO = 3
o63		dq	 0.44547727214752494037253194812	; 0.63 / sqrt(2)
 %else
o63		dq	 0.63
 %endif

section .text

; Window[i]=0.63*(.42-.5*cos(2*PI*(i+.5)/FFTSIZE)+.08*cos(4*PI*(i+.5)/FFTSIZE))

%ifdef static
  %if PRO
	%define  VocInit  MXinit_pro
	%define _VocInit _MXinit_pro
  %else
	%define  VocInit  MXinit
	%define _VocInit _MXinit
  %endif
%endif

global	VocInit
global _VocInit
 VocInit:
_VocInit:
    %push mycontext
    %stacksize flat
    %arg vb:dword
    %assign %$localsize 0
    %local pad1:dword, const0:dword, cw:word
;   %local const0:qword, cw:word    <- qword offsets wrong!
	    ; ^2*PI/FFTSIZE

    push   ebp
    mov    ebp,esp
    add    esp,byte -%$localsize
    push   ebx
    push   ecx
		mov	ebx,[vb]
;;;		.if [ebx].VB.Version != VERSION
    cmp    dword [ebx + VB.Version], VERSION
    je	   @C0041
			or	eax,byte -1

;;;		.else
    jmp    @C0043
@C0041:
			mov	dword [ebx+VB.Threshold],20000h ; Default 2.0

			mov	ecx,[ebx+VB.InBuff]
			add	ecx,byte 15
			and	ecx,byte -16
			mov	[ebx+VB.InBuff],ecx

			mov	ecx,[ebx+VB.OutBuff]
			add	ecx,byte 15
			and	ecx,byte -16
			mov	[ebx+VB.OutBuff],ecx

			mov	ecx,[ebx+VB.Comp]
			add	ecx,byte 15
			and	ecx,byte -16

			mov	[ebx+VB.Comp],ecx
			add	ecx,MAXFFTSIZE*real4*2
			mov	[ebx+VB.Window],ecx
			add	ecx,MAXFFTSIZE*real4
			mov	[ebx+VB.OutL],ecx
			add	ecx,MAXFFTSIZE*real4
			mov	[ebx+VB.OutR],ecx
			add	ecx,MAXFFTSIZE*real4
			mov	[ebx+VB.OldInPhaseL],ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx+VB.OutPhaseL],ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx+VB.OldInPhaseR],ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx+VB.OutPhaseR],ecx
			add	ecx,MAXFFTSIZE/2*real4
			mov	[ebx+VB.PeakL],ecx
			add	ecx,MAXFFTSIZE/2*4
			mov	[ebx+VB.PeakR],ecx
			add	ecx,MAXFFTSIZE/2*4
			mov	[ebx+VB.MagnS],ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx+VB.RealA],ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx+VB.ImagA],ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx+VB.RealB],ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx+VB.ImagB],ecx
			add	ecx,(MAXFFTSIZE/2+4)*real4
			mov	[ebx+VB.EnergyL],ecx
			add	ecx,byte 3*real4
			mov	[ebx+VB.EnergyR],ecx

			mov	word [const0],FFTSIZE >> (PRO+1)
			fnstcw	[cw]			; save FPU control word
			fninit				; reinitialize FPU
			fldpi
			fidiv	word [const0]
			fstp	qword [const0]
			mov	ebx,[ebx+VB.Window]
			mov	ecx,FFTSIZE >> PRO
			fld	qword [minus05]
;;;			.repeat
@C0044:
				fld1
				faddp	st1,st0 		; update i+.5
				fst	st2
				fmul	qword [const0]		; 2*PI*(i+.5)/FFTSIZE
				fst	st1			; angle for left cos
				fadd	st0,st0 		;   "   "
				fcos				; right cos
				fmul	qword [o08]		; rightmost intermediate sum
				fxch				; store it and load angle for
				fcos				; left cos
				fmul	qword [minus05]
				faddp	st1,st0
				fadd	qword [o42]
				fmul	qword [o63]
				fstp	dword [ebx]		; store item and pop i+0.5
				add	ebx,byte real4		; update pointer
;;;			.untilcxz			; repeat FFTSIZE times
    loop   @C0044
			fstp	st0			; restore FPU stack
			fldcw	[cw]			; restore FPU control word
;;;		.endif
@C0043:

;;;		ret
    pop    ecx
    pop    ebx
    leave
    ret
    %pop
