%ifndef FLOAT_DATA
  FLOAT_DATA	EQU	0	; 0 - integer data, 1 - float data
%endif

VERSION		EQU	10200h+FLOAT_DATA	; 1.02

%ifndef PRO
  PRO		EQU	0	; 0 - use FAST algorithm, 1 - use PROFESSIONAL algorithm
%endif

%ifndef FFTBITS
  FFTBITS	EQU	12
%endif

FFTSIZE		EQU	1 << FFTBITS

MAXFFTSIZE	EQU	4096	; Maximum FFT size for all library versions
%if FFTSIZE > MAXFFTSIZE
   MAXFFTSIZE	EQU	FFTSIZE
%endif

%ifndef OVERLAP
  OVERLAP	EQU	2
%endif

OVERSAMPBITS	EQU	OVERLAP+PRO
OVERSAMP	EQU	1 << OVERSAMPBITS
HOPSIZE		EQU	FFTSIZE/OVERSAMP

SAMPLESIZE	EQU	4*(1+FLOAT_DATA)

%if FLOAT_DATA
 %define IODATATYPE	real4
%else
 %define IODATATYPE	2
%endif

MEMBLOCK	EQU	172152

HOPSIZE_shift	EQU	FFTBITS-OVERSAMPBITS	;  log2(HOPSIZE)
InStep_shift	EQU	16-HOPSIZE_shift	; -log2(HOPSIZE/10000h)


struc	VB		; VocodeBuffer

 .Version	resd	1	; fixed point 16.16
 		alignb	8
 .InBuff	resd	1	; I(F)TYPE[INBLOCKSAM*2]   Input buffer address
 .OutBuff	resd	1	; I(F)TYPE[OUTBLOCKSAM*n] Output buffer address

 .Comp		resd	1	; Complex[FFTSIZE]	Calc buffers
 .Window	resd	1	; FTYPE[FFTSIZE]	Window function
 .OutL		resd	1	; FTYPE[FFTSIZE]	Mixing output
 .OutR		resd	1	; FTYPE[FFTSIZE]	Mixing output
 .OldInPhaseL	resd	1	; FTYPE[FFTSIZE/2]	Signal phases
 .OutPhaseL	resd	1	; FTYPE[FFTSIZE/2]	Signal phases
 .OldInPhaseR	resd	1	; FTYPE[FFTSIZE/2]	Signal phases
 .OutPhaseR	resd	1	; FTYPE[FFTSIZE/2]	Signal phases
 .PeakL		resd	1	; int[FFTSIZE/2]	Spectrum peak values
 .PeakR		resd	1	; int[FFTSIZE/2]	Spectrum peak values
 .MagnS		resd	1	; FTYPE[FFTSIZE/2+4]	Calc buffer
 .RealA		resd	1	; FTYPE[FFTSIZE/2+4]	Calc buffer
 .ImagA		resd	1	; FTYPE[FFTSIZE/2+4]	Calc buffer
 .RealB		resd	1	; FTYPE[FFTSIZE/2+4]	Calc buffer
 .ImagB		resd	1	; FTYPE[FFTSIZE/2+4]	Calc buffer
 .EnergyL	resd	1	; FTYPE[3]		Energy of blocks
 .EnergyR	resd	1	; FTYPE[3]		Energy of blocks

 .InBuffOfs	resd	1	;			Current position in buffer
 .OutBuffOfs	resd	1	;			Current position in buffer
 .AttackL	resw	1	;			Block with attack flag
 .AttackR	resw	1	;			Block with attack flag

 .InBlkSz	resd	1	;  Input buffer size [bytes]
 .OutBlkSz	resd	1	; Output buffer size [bytes]
 .QuadInBlSamsk	resd	1	; (4*INBLOCKSAM-1)*IODATATYPE (mask)
 .QuadInBlSmask	resd	1	;  4*INBLOCKSAM-1 (mask)
 .DualInBlSmask	resd	1	;  2*INBLOCKSAM-1 (mask)
 .DualInblSam	resd	1	;  2*INBLOCKSAM
 .InBlkSamShInc	resb	1	;    INBLOCKSAM_shift+1
 .OutBlkHops	resb	1	; OUTBLOCKSAM/HOPSIZE
 		alignb	4

 .Speed		resd	1	; Tempo of playback, fixed point 16.16
 .Threshold	resd	1	; Attack detection level, fixed point 16.16
 .Last		resd	1	; Bytes to read last before data end, aligned at 4 bytes
 .Empty		resb	1	; Set when ready to fill Buffer
 .Half		resb	1	; Current played half of input buffer (0,1)
 .E0F		resb	1	; 0: no data end, 1: in first half, 2: in second
 .LastFilledBuf resb	1	; No. of last filled out buffer half
 .OutBufferSzKB	resb	1	; Output Buffer Size [KB]: 2*,4*,8,16,32 (*not always)
 .fpu		resb	1	; 0 - use FPU, 1 - use 3DNow!, 2 - use SSE

endstruc	; VB
