ifndef FLOAT_DATA
  FLOAT_DATA	=	0	; 0 - integer data, 1 - float data
endif

VERSION		=	10200h+FLOAT_DATA	; 1.02

ifndef PRO
  PRO		=	0	; 0 - use FAST algorithm, 1 - use PROFESSIONAL algorithm
endif

ifndef FFTBITS
  FFTBITS	=	12
endif

FFTSIZE		=	1 shl FFTBITS

MAXFFTSIZE	=	4096	; Maximum FFT size for all library versions
if FFTSIZE gt MAXFFTSIZE
  MAXFFTSIZE	=	FFTSIZE
endif

ifndef OVERLAP
  OVERLAP	=	2
endif

OVERSAMPBITS	=	OVERLAP+PRO
OVERSAMP	=	1 shl OVERSAMPBITS
HOPSIZE		=	FFTSIZE/OVERSAMP

SAMPLESIZE	=	4*(1+FLOAT_DATA)

if FLOAT_DATA
 IODATATYPE	textequ <real4>
else
 IODATATYPE	textequ <word>
endif

MEMBLOCK	=	172152

HOPSIZE_shift	=	FFTBITS-OVERSAMPBITS	;  log2(HOPSIZE)
InStep_shift	=	16-HOPSIZE_shift	; -log2(HOPSIZE/10000h)


VB		struct		; VocodeBuffer

  Version	dword	?	; fixed point 16.16
		align	8
  InBuff	dword	?	; I(F)TYPE[INBLOCKSAM*2]   Input buffer address
  OutBuff	dword	?	; I(F)TYPE[OUTBLOCKSAM*n] Output buffer address

  Comp		dword	?	; Complex[FFTSIZE]	Calc buffers
  Window	dword	?	; FTYPE[FFTSIZE]	Window function
  OutL		dword	?	; FTYPE[FFTSIZE]	Mixing output
  OutR		dword	?	; FTYPE[FFTSIZE]	Mixing output
  OldInPhaseL	dword	?	; FTYPE[FFTSIZE/2]	Signal phases
  OutPhaseL	dword	?	; FTYPE[FFTSIZE/2]	Signal phases
  OldInPhaseR	dword	?	; FTYPE[FFTSIZE/2]	Signal phases
  OutPhaseR	dword	?	; FTYPE[FFTSIZE/2]	Signal phases
  PeakL		dword	?	; int[FFTSIZE/2]	Spectrum peak values
  PeakR		dword	?	; int[FFTSIZE/2]	Spectrum peak values
  MagnS		dword	?	; FTYPE[FFTSIZE/2+4]	Calc buffer
  RealA		dword	?	; FTYPE[FFTSIZE/2+4]	Calc buffer
  ImagA		dword	?	; FTYPE[FFTSIZE/2+4]	Calc buffer
  RealB		dword	?	; FTYPE[FFTSIZE/2+4]	Calc buffer
  ImagB		dword	?	; FTYPE[FFTSIZE/2+4]	Calc buffer
  EnergyL	dword	?	; FTYPE[3]		Energy of blocks
  EnergyR	dword	?	; FTYPE[3]		Energy of blocks

  InBuffOfs	dword	?	;			Current position in buffer
  OutBuffOfs	dword	?	;			Current position in buffer
  AttackL	word	?	;			Block with attack flag
  AttackR	word	?	;			Block with attack flag

  InBlkSz	dword	?	;  Input buffer size [bytes]
  OutBlkSz	dword	?	; Output buffer size [bytes]
  QuadInBlSamsk	dword	?	; (4*INBLOCKSAM-1)*IODATATYPE (mask)
  QuadInBlSmask	dword	?	;  4*INBLOCKSAM-1 (mask)
  DualInBlSmask	dword	?	;  2*INBLOCKSAM-1 (mask)
  DualInblSam	dword	?	;  2*INBLOCKSAM
  InBlkSamShInc	byte	?	;    INBLOCKSAM_shift+1
  OutBlkHops	byte	?	; OUTBLOCKSAM/HOPSIZE
		align	4

  Speed		dword	?	; Tempo of playback, fixed point 16.16
  Threshold	dword	?	; Attack detection level, fixed point 16.16
  Last		dword	?	; Bytes to read last before data end, aligned at 4 bytes
  Empty		byte	?	; Set when ready to fill Buffer
  Half		byte	?	; Current played half of input buffer (0,1)
  E0F		byte	?	; 0: no data end, 1: in first half, 2: in second
  LastFilledBuf	byte	?	; No. of last filled out buffer half
  OutBufferSzKB	byte	?	; Output Buffer Size [KB]: 2*,4*,8,16,32 (*not always)
  fpu		byte	?	; 0 - use FPU, 1 - use 3DNow!, 2 - use SSE

VB	ends
